if (!Array.prototype.indexOf) {
	Array.prototype.indexOf = function(elt) {
		var len = this.length;
		var from = Number(arguments[1]) || 0;
		from = (from < 0)
			? Math.ceil(from)
			: Math.floor(from);
		if (from < 0)
		from += len;

		for (; from < len; from++) {
			if (from in this && this[from] === elt)
			return from;
		}
		return -1;
	};
}

var RegisteredObjectNames = new Array();

function createCookie(name,value,days) {
	if(RegisteredObjectNames.indexOf(name)<0 && days!=-1) {
		RegisteredObjectNames.push(name);
	}
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*86400000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+encodeURIComponent(value)+expires+"; path=/";
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) {
			if(RegisteredObjectNames.indexOf(name)<0) {
				RegisteredObjectNames.push(name);
			}
			return decodeURIComponent(c.substring(nameEQ.length,c.length));
		}
	}
	return null;
}

function eraseCookie(name) {
	try{RegisteredObjectNames.splice(RegisteredObjectNames.indexOf(name),1);}catch(e){}
	createCookie(name,"",-1);
}

function SetObjectValue(Obj,d) {
	if(Obj.type=="select-one") {
		for(var i=0;i<Obj.length;i++) {
			if(Obj.options[i].value==d) {
				d=Obj.options[i].index;
				Obj.selectedIndex=d;
				break;
			}
		}
	}
	else if(Obj.type=="checkbox") {
		if(d){d="checked";}else{d="";}
		Obj.checked=(d);
	}
	else {
		Obj.value=d;
	}
}

function SetObjectValueID(id,d) {
	SetObjectValue(document.getElementById(id),d);
}

function deleteAllCookies() {
	while(RegisteredObjectNames.length>0) {
		eraseCookie(RegisteredObjectNames[0]);
	}
}

function GetInputObjCookie(Obj) {
	var d=readCookie(Obj.id);
	if(d==null) {
		d=Obj.value;
	}
	SetObjectValue(Obj,d);
	return d;
}

function GetCheckBoxObjCookie(Obj) {
	var d=readCookie(Obj.id);
	if(d==null) {
		d=""+Obj.checked;
	}
	d=(d=="true");
	SetObjectValue(Obj,d);
	return d;
}

function GetSelectObjCookie(Obj) {
	var d=readCookie(Obj.id);
	if(d==null) {
		d=Obj.value;
	}
	SetObjectValue(Obj,d);
	return d;
}

function GetObjCookie(Obj) {
	var t=Obj.type;
	if(t=="text" || t=="hidden"){return GetInputObjCookie(Obj);}
	if(t=="select-one"){return GetSelectObjCookie(Obj);}
	if(t=="checkbox"){return GetCheckBoxObjCookie(Obj);}
	return null;
}

function SetInputObjCookie(Obj) {
	var d=Obj.value;
	createCookie(Obj.id,d);
}

function SetCheckBoxObjCookie(Obj) {
	var d=""+(Obj.checked);
	createCookie(Obj.id,d);
}

function SetSelectObjCookie(Obj) {
	var d=Obj.value;
	createCookie(Obj.id,d);
}

function SetObjCookie(Obj) {
	var t=Obj.type;
	if(t=="text" || t=="hidden"){SetInputObjCookie(Obj);}
	if(t=="select-one"){SetSelectObjCookie(Obj);}
	if(t=="checkbox"){SetCheckBoxObjCookie(Obj);}
}

function EraseInputObjCookie(Obj) {
	var d=readCookie(Obj.id);
	eraseCookie(Obj.id);
	if(d==null) {
		d=Obj.value;
	}
	Obj.value=d;
	return d;
}

function EraseCheckBoxObjCookie(Obj) {
	var d=readCookie(Obj.id);
	eraseCookie(Obj.id);
	if(d==null) {
		d=""+Obj.checked;
	}
	d=(d=="true");
	Obj.checked=d;
	return d;
}

function EraseSelectObjCookie(Obj) {
	var d=readCookie(Obj.id);
	eraseCookie(Obj.id);
	if(d==null) {
		d=Obj.value;
	}
	for(var i=0;i<Obj.length;i++) {
		if(Obj.options[i].value==d) {
			d=Obj.options[i].index;
			Obj.selectedIndex=d;
			return Obj.options[i].value;
		}
	}
	return d;
}

function EraseObjCookie(Obj) {
	var t=Obj.type;
	if(t=="text" || t=="hidden"){return EraseInputObjCookie(Obj);}
	if(t=="select-one"){return EraseSelectObjCookie(Obj);}
	if(t=="checkbox"){return EraseCheckBoxObjCookie(Obj);}
	return null;
}

var KillDoUpdate=false;
var KillDoUpdateStack=new Array(0);
function PushUpdateKill() {
	KillDoUpdateStack.push(KillDoUpdate);
	KillDoUpdate=true;
}
function PopUpdateKill() {
	if(KillDoUpdateStack.length>0) {
		KillDoUpdate=KillDoUpdateStack.pop();
	}
	else {
		KillDoUpdate=false;
	}
}

function GetAllSettings() {
	var Res="";
	for(var i=0;i < RegisteredObjectNames.length;i++) {
		var name = RegisteredObjectNames[i];
		var Obj=document.getElementById(name);
		if(Obj==null || Obj==undefined)continue;
		Res+=name+"="+(encodeURI(GetObjCookie(Obj)))+"\r\n";
	}
	return Res;
}

function CallObjectChanged(Obj) {
	if(Obj==null || Obj==undefined)return;
	var fe=(Obj.onchange || Obj.onclick);
	if(fe==null || fe==undefined)return;
	evt=new Event(Obj);
	evt.target=Obj;
	evt.srcElement=Obj;
	var oe=window.event;
	try {
		window.event=evt;
	}
	catch(e) {
		fe(evt);
		delete evt;
		return;
	}
	fe(evt);
	window.event=oe;
	delete evt;
}

function PutAllSettings(data) {
	PushUpdateKill();
	deleteAllCookies();
	data=data.split("\r\n");
	data=data.join(";");
	data=data.split("\r");
	data=data.join(";");
	data=data.split("\n");
	data=data.join(";");
	data=data.split(";");
	var datafail = new Array;
	var FailPass=0;
	while(FailPass<2) {
		for(var i=0;i<data.length;i++) {
			var t=data[i];
			t=t.split("=");
			var z=t.shift();if(z==""){continue;}
			t=t.join("=");
			var a=decodeURI(t);
			var vi=document.getElementById(z);
			if(vi!=null && vi!=undefined) {
				if(vi.type=="button") {
					continue;
				}
				createCookie(z,a);
				GetObjCookie(vi);
				CallObjectChanged(vi);
			}
			else {
				if(FailPass<1) {
					datafail.push(z+"="+t);
				}
			}
		}
		delete data;
		if(FailPass==0)
		{
			data=datafail;datafail=null;
		}
		FailPass++;
	}
	if(data!=null)delete data;
	PopUpdateKill();
	DoUpdate();
}

function RetoolPathDelimiters(Obj,nd) {
	var t=new String(Obj.value);
	var ot=t;
	var od="\\";
	if(od==nd){od="/";}
	if(t.indexOf(nd)!=-1)return;
	var a=t.split(od);
	t=a.join(nd);
	if(t!=ot) {
		SetObjectValue(Obj,t);
		SetObjCookie(Obj);
		CallObjectChanged(Obj);
	}
}

var linux="\n";
var windows="\r\n";
var macintosh="\r";

var linuxPD="/";
var windowsPD="\\";
var macintoshPD="/";

var CPD;
var NumOfPlaylists=0;
var PlaylistMultiSymNameArray = new Array(NumOfPlaylists);
var PlaylistMultiFileArray = new Array(NumOfPlaylists);
var BufferType;
var AdaptiveBufferSize;
var FixedBufferSize;
var BufferHardLimit;
var MaxHeaderLineSize;
var MaxHeaderLineCount;
var NameLookups;
var Platform;
var DNASBasePath;
var TranscoderBasePath;
var DNASConfFile;
var TransConfFile;
var Mode;
var DNASPublic;
var SCTransPublic;
var MetaInterval;
var YPAddr;
var YPPort;
var YPPath;
var YPTimeout;
var YPMaxRetries;
var YPReportInterval;
var YPMinReportInterval;
var PortBase;
var NumOfEndPoints;
var NumOfCalendarEvents=0;
var CalendarEventTypeArray = new Array(NumOfCalendarEvents);
var CalendarDJArchiveArray = new Array(NumOfCalendarEvents);
var CalendarDJNameArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistLoopAtEndArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistShuffleArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistPriorityArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistNameArray = new Array(NumOfCalendarEvents);
var CalendarRelayURLArray = new Array(NumOfCalendarEvents);
var CalendarRelayPriorityArray = new Array(NumOfCalendarEvents);
var CalendarPerArray = new Array(NumOfCalendarEvents);
var CalendarSunArray = new Array(NumOfCalendarEvents);
var CalendarMonArray = new Array(NumOfCalendarEvents);
var CalendarTueArray = new Array(NumOfCalendarEvents);
var CalendarWedArray = new Array(NumOfCalendarEvents);
var CalendarThuArray = new Array(NumOfCalendarEvents);
var CalendarFriArray = new Array(NumOfCalendarEvents);
var CalendarSatArray = new Array(NumOfCalendarEvents);
var CalendarStartDateArray = new Array(NumOfCalendarEvents);
var CalendarEndDateArray = new Array(NumOfCalendarEvents);
var CalendarStartTimeArray = new Array(NumOfCalendarEvents);
var CalendarDurationArray = new Array(NumOfCalendarEvents);
var CalendarTimeOffsetArray = new Array(NumOfCalendarEvents);
var DNASIP;
var SourceBindAddress;
var DestinationBindAddress;
var TransAdminPort;
var Password;
var AdminPassword;
var VUImageDirectory;
var VUImageSuffix;
var VUImageMimeType;
var DNASFlashPolicyFile;
var FlashPolicyFile;
var FlashPolicyServerPort;
var BanFile;
var RipFile;
var RipOnly;
var MaxListeners;
var ListenerTime;
var AutoDumpUsers;
var DNASDebugMode;
var TransDebugMode;
var YP1Debug;
var YP2Debug;
var SHOUTcastSourceDebug;
var UVOX2SourceDebug;
var SHOUTcast1ClientDebug;
var SHOUTcast2ClientDebug;
var RelaySHOUTcastDebug;
var RelayUVOXDebug;
var RelayDebug;
var StreamDataDebug;
var HTTPStyleDebug;
var StatsDebug;
var MicroServerDebug;
var ThreadRunnerDebug;
var RTMPClientDebug;
var ShuffleDebug;
var SHOUTcastDebug;
var UVOXDebug;
var GainDebug;
var PlaylistDebug;
var MP3EncDebug;
var MP3DecDebug;
var ResamplerDebug;
var RGCalcDebug;
var APIDebug;
var CalendarDebug;
var CaptureDebug;
var DJDebug;
var FlashPolicyServerDebug;
var FileConverterDebug;
var SourceRelayDebug;
var SourceAndEndpointManagerDebug;
var StreamTitle;
var StreamURL;
var StreamGenre;
var AIM;
var IRC;
var ICQ;
var UseMetadata;
var MetadataPattern;
var DisplayMetadataPattern;
var TitleFormat;
var URLFormat;
var Screenlog;
var EnableLogging;
var DNASLogFile;
var TransLogFile;
var W3CLogging;
var W3CLogFile;
var WebClientDebug;
var CalendarFile;
var CalendarEnableRewrite;
var CalendarEventAddButton;
var PlaylistFile;
var EnableShuffle;
var XFadeTime;
var XFadeThreshold;
var PlaylistFolder;
var PlaylistArchiveFolder;
var DJPort;
var DJPort2;
var DJCipher;
var DJAutoDumpSourceTime;
var DJCaptureEnable;
var DJBroadcastsPath;
var DJFilePattern;
var NumOfDJs=0;
var DJLoginArray = new Array(NumOfDJs);
var DJPasswordArray = new Array(NumOfDJs);
var DJPriorityArray = new Array(NumOfDJs);
var EnableCapture;
var CaptureDevice;
var CaptureInput;
var CaptureSampleRate;
var CaptureNumChannels;
var ApplyReplayGain;
var DefaultReplayGain;
var DJReplayGain;
var CaptureReplayGain;
var CalculateReplayGain;
var ReplayGainTempFolder;
var ReplayGainRunAhead;
var ReplayGainDontWrite;
var EnhanceReplayGain;
var MP3UnlockKeyName;
var MP3UnlockKeyCode;
var DefaultAuthHash;
var DNASConfigreWrite;
var TransConfigreWrite;
var DNASAdminPageTheme;
var TimeMultiplier;
var DNASIntroFile;
var DNASBackupFile;
var DNASSpecialFileTmpDir;
var MaxSpecialFileSize;
var ServerBackupFile;
var ServerIntroFile;
var SongHistory;

function SetDefaults() {
	CPD=windowsPD;
	NumOfPlaylists=0;SetObjectValueID("NumOfPlaylistsHidden",NumOfPlaylists);
	delete PlaylistMultiSymNameArray;PlaylistMultiSymNameArray = new Array(NumOfPlaylists);for(var i=0;i<NumOfPlaylists;i++){PlaylistMultiSymNameArray[i]="";}
	delete PlaylistMultiFileArray;PlaylistMultiFileArray = new Array(NumOfPlaylists);for(var i=0;i<NumOfPlaylists;i++){PlaylistMultiFileArray[i]="";}
	BufferType=0;SetObjectValueID("BufferTypeSelect",BufferType);
	AdaptiveBufferSize=1;SetObjectValueID("AdaptiveBufferSizeInput",AdaptiveBufferSize);
	FixedBufferSize=1048576;SetObjectValueID("FixedBufferSizeInput",FixedBufferSize);
	BufferHardLimit=16777216;SetObjectValueID("BufferHardLimitInput",BufferHardLimit);
	MaxHeaderLineSize=2048;SetObjectValueID("MaxHeaderLineSizeInput",MaxHeaderLineSize);
	MaxHeaderLineCount=100;SetObjectValueID("MaxHeaderLineCountInput",MaxHeaderLineCount);
	NameLookups=false;SetObjectValueID("NameLookupsCheckBox",NameLookups);
	Platform=1;SetObjectValueID("PlatformSelect",Platform);
	DNASBasePath="";SetObjectValueID("DNASBasePathInput",DNASBasePath);
	TranscoderBasePath="";SetObjectValueID("TranscoderBasePathInput",TranscoderBasePath);
	DNASConfFile="sc_serv.conf";SetObjectValueID("DNASConfFileInput",DNASConfFile);
	TransConfFile="sc_trans.conf";SetObjectValueID("TransConfFileInput",TransConfFile);
	Mode=2;SetObjectValueID("ModeSelect",Mode);
	DNASPublic="default";SetObjectValueID("DNASPublicSelect",DNASPublic);
	SCTransPublic=false;SetObjectValueID("TransPublicCheckBox",SCTransPublic);
	MetaInterval=8192;SetObjectValueID("MetaIntervalInput",MetaInterval);
	YPAddr="yp.shoutcast.com";SetObjectValueID("YPAddrInput",YPAddr);
	YPPort=80;SetObjectValueID("YPPortInput",YPPort);
	YPPath="/yp2";SetObjectValueID("YPPathInput",YPPath);
	YPTimeout=60;SetObjectValueID("YPTimeoutInput",YPTimeout);
	YPMaxRetries=10;SetObjectValueID("YPMaxRetriesInput",YPMaxRetries);
	YPReportInterval=300;SetObjectValueID("YPReportIntervalInput",YPReportInterval);
	YPMinReportInterval=10;SetObjectValueID("YPMinReportIntervalInput",YPMinReportInterval);
	PortBase=8000;SetObjectValueID("PortBaseInput",PortBase);
	NumOfEndPoints=2;SetObjectValueID("NumOfEndPointsInput",NumOfEndPoints);
	DNASIP="localhost";SetObjectValueID("DNASIPInput",DNASIP);
	SourceBindAddress="";SetObjectValueID("SourceBindAddressInput",SourceBindAddress);
	DestinationBindAddress="";SetObjectValueID("DestinationBindAddressInput",DestinationBindAddress);
	TransAdminPort=0;SetObjectValueID("TransAdminPortInput",TransAdminPort);
	Password="******";SetObjectValueID("PasswordInput",Password);
	AdminPassword="**********";SetObjectValueID("AdminPasswordInput",AdminPassword);
	VUImageDirectory="vuimages\\";SetObjectValueID("VUImageDirectoryInput",VUImageDirectory);
	VUImageSuffix="png";SetObjectValueID("VUImageSuffixInput",VUImageSuffix);
	VUImageMimeType="image/png";SetObjectValueID("VUImageMimeTypeInput",VUImageMimeType);
	DNASFlashPolicyFile="crossdomain.xml";SetObjectValueID("DNASFlashPolicyFileInput",DNASFlashPolicyFile);
	FlashPolicyFile="crossdomain.xml";SetObjectValueID("FlashPolicyFileInput",FlashPolicyFile);
	FlashPolicyServerPort=0;SetObjectValueID("FlashPolicyServerPortInput",FlashPolicyServerPort);
	BanFile="sc_serv.ban";SetObjectValueID("BanFileInput",BanFile);
	RipFile="sc_serv.rip";SetObjectValueID("RipFileInput",RipFile);
	RipOnly=false;SetObjectValueID("RipOnlyCheckBox",RipOnly);
	MaxListeners=32;SetObjectValueID("MaxListenersInput",MaxListeners);
	ListenerTime=0;SetObjectValueID("ListenerTimeInput",ListenerTime);
	AutoDumpUsers=false;SetObjectValueID("AutoDumpUsersCheckBox",AutoDumpUsers);
	YP1Debug=false;SetObjectValueID("YP1DebugCheckBox",YP1Debug);
	YP2Debug=false;SetObjectValueID("YP2DebugCheckBox",YP2Debug);
	SHOUTcastSourceDebug=false;SetObjectValueID("SHOUTcastSourceDebugCheckBox",SHOUTcastSourceDebug);
	UVOX2SourceDebug=false;SetObjectValueID("UVOX2SourceDebugCheckBox",UVOX2SourceDebug);
	SHOUTcast1ClientDebug=false;SetObjectValueID("SHOUTcast1ClientDebugCheckBox",SHOUTcast1ClientDebug);
	SHOUTcast2ClientDebug=false;SetObjectValueID("SHOUTcast2ClientDebugCheckBox",SHOUTcast2ClientDebug);
	RelaySHOUTcastDebug=false;SetObjectValueID("RelaySHOUTcastDebugCheckBox",RelaySHOUTcastDebug);
	RelayUVOXDebug=false;SetObjectValueID("RelayUVOXDebugCheckBox",RelayUVOXDebug);
	RelayDebug=false;SetObjectValueID("RelayDebugCheckBox",RelayDebug);
	StreamDataDebug=false;SetObjectValueID("StreamDataDebugCheckBox",StreamDataDebug);
	HTTPStyleDebug=false;SetObjectValueID("HTTPStyleDebugCheckBox",HTTPStyleDebug);
	StatsDebug=false;SetObjectValueID("StatsDebugCheckBox",StatsDebug);
	MicroServerDebug=false;SetObjectValueID("MicroServerDebugCheckBox",MicroServerDebug);
	ThreadRunnerDebug=false;SetObjectValueID("ThreadRunnerDebugCheckBox",ThreadRunnerDebug);
	RTMPClientDebug=false;SetObjectValueID("RTMPClientDebugCheckBox",RTMPClientDebug);
	DNASDebugMode=0;SetObjectValueID("DNASDebugModeHidden",DNASDebugMode);
	TransDebugMode=0;SetObjectValueID("TransDebugModeHidden",TransDebugMode);
	ShuffleDebug=false;SetObjectValueID("ShuffleDebugCheckBox",ShuffleDebug);
	SHOUTcastDebug=false;SetObjectValueID("SHOUTcastDebugCheckBox",SHOUTcastDebug);
	UVOXDebug=false;SetObjectValueID("UVOXDebugCheckBox",UVOXDebug);
	GainDebug=false;SetObjectValueID("GainDebugCheckBox",GainDebug);
	PlaylistDebug=false;SetObjectValueID("PlaylistDebugCheckBox",PlaylistDebug);
	MP3EncDebug=false;SetObjectValueID("MP3EncDebugCheckBox",MP3EncDebug);
	MP3DecDebug=false;SetObjectValueID("MP3DecDebugCheckBox",MP3DecDebug);
	ResamplerDebug=false;SetObjectValueID("ResamplerDebugCheckBox",ResamplerDebug);
	RGCalcDebug=false;SetObjectValueID("RGCalcDebugCheckBox",RGCalcDebug);
	APIDebug=false;SetObjectValueID("APIDebugCheckBox",APIDebug);
	CalendarDebug=false;SetObjectValueID("CalendarDebugCheckBox",CalendarDebug);
	CaptureDebug=false;SetObjectValueID("CaptureDebugCheckBox",CaptureDebug);
	DJDebug=false;SetObjectValueID("DJDebugCheckBox",DJDebug);
	FlashPolicyServerDebug=false;SetObjectValueID("FlashPolicyServerDebugCheckBox",FlashPolicyServerDebug);
	FileConverterDebug=false;SetObjectValueID("FileConverterDebugCheckBox",FileConverterDebug);
	SourceRelayDebug=false;SetObjectValueID("SourceRelayDebugCheckBox",SourceRelayDebug);
	SourceAndEndpointManagerDebug=false;SetObjectValueID("SourceAndEndpointManagerDebugCheckBox",SourceAndEndpointManagerDebug);
	StreamTitle="Unnamed Server";SetObjectValueID("StreamTitleInput",StreamTitle);
	StreamURL="http://www.shoutcast.com/";SetObjectValueID("StreamURLInput",StreamURL);
	StreamGenre="Misc";SetObjectValueID("StreamGenreInput",StreamGenre);
	AIM="";SetObjectValueID("AIMInput",AIM);
	IRC="";SetObjectValueID("IRCInput",IRC);
	ICQ="";SetObjectValueID("ICQInput",ICQ);
	UseMetadata=true;SetObjectValueID("UseMetadataCheckBox",UseMetadata);
	MetadataPattern="";SetObjectValueID("MetadataPatternInput",MetadataPattern);
	DisplayMetadataPattern="";SetObjectValueID("DisplayMetadataPatternInput",DisplayMetadataPattern);
	TitleFormat="";SetObjectValueID("TitleFormatInput",TitleFormat);
	URLFormat="";SetObjectValueID("URLFormatInput",URLFormat);
	Screenlog=true;SetObjectValueID("ScreenlogCheckBox",Screenlog);
	EnableLogging=true;SetObjectValueID("EnableLoggingCheckBox",EnableLogging);
	DNASLogFile="sc_serv.log";SetObjectValueID("DNASLogFileInput",DNASLogFile);
	TransLogFile="sc_trans.log";SetObjectValueID("TransLogFileInput",TransLogFile);
	W3CLogging=false;SetObjectValueID("W3CLoggingCheckBox",W3CLogging);
	W3CLogFile="sc_w3c.log";SetObjectValueID("W3CLogFileInput",W3CLogFile);
	WebClientDebug=false;SetObjectValueID("WebClientDebugCheckBox",WebClientDebug);
	CalendarFile="calendar.xml";SetObjectValueID("CalendarFileInput",CalendarFile);
	CalendarEnableRewrite=false;SetObjectValueID("CalendarEnableRewriteCheckBox",CalendarEnableRewrite);
	PlaylistFile="playlist.lst";SetObjectValueID("PlaylistFileInput",PlaylistFile);
	EnableShuffle=false;SetObjectValueID("EnableShuffleCheckBox",EnableShuffle);
	XFadeTime=1;SetObjectValueID("XFadeTimeInput",XFadeTime);
	XFadeThreshold=10;SetObjectValueID("XFadeThresholdInput",XFadeThreshold);
	PlaylistFolder="playlist\\";SetObjectValueID("PlaylistFolderInput",PlaylistFolder);
	PlaylistArchiveFolder="archived\\";SetObjectValueID("PlaylistArchiveFolderInput",PlaylistArchiveFolder);
	DJPort=0;SetObjectValueID("DJPortInput",DJPort);
	DJPort2=0;SetObjectValueID("DJPort2Input",DJPort2);
	DJCipher="";SetObjectValueID("DJCipherInput",DJCipher);
	DJAutoDumpSourceTime=30;SetObjectValueID("DJAutoDumpSourceTimeInput",DJAutoDumpSourceTime);
	DJCaptureEnable=false;SetObjectValueID("DJCaptureEnableCheckBox",DJCaptureEnable);
	DJBroadcastsPath=".\\recorded\\";SetObjectValueID("DJBroadcastsPathInput",DJBroadcastsPath);
	DJFilePattern="";SetObjectValueID("DJFilePatternInput",DJFilePattern);
	NumOfDJs=0;SetObjectValueID("NumOfDJsHidden",NumOfDJs);
	delete DJLoginArray;DJLoginArray = new Array(NumOfDJs);for(var i=0;i<NumOfDJs;i++){DJLoginArray[i]="";}
	delete DJPasswordArray;DJPasswordArray = new Array(NumOfDJs);for(var i=0;i<NumOfDJs;i++){DJPasswordArray[i]="";}
	delete DJPriorityArray;DJPriorityArray = new Array(NumOfDJs);for(var i=0;i<NumOfDJs;i++){DJPriorityArray[i]=1;}
	NumOfCalendarEvents=0;SetObjectValueID("NumOfCalendarEventsHidden",NumOfCalendarEvents);
	delete CalendarEventTypeArray;CalendarEventTypeArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarEventTypeArray[i]="";}
	delete CalendarDJArchiveArray;CalendarDJArchiveArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarDJArchiveArray[i]="";}
	delete CalendarDJNameArray;CalendarDJNameArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarDJNameArray[i]="";}
	delete CalendarPlaylistLoopAtEndArray;CalendarPlaylistLoopAtEndArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarPlaylistLoopAtEndArray[i]="";}
	delete CalendarPlaylistShuffleArray;CalendarPlaylistShuffleArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarPlaylistShuffleArray[i]="";}
	delete CalendarPlaylistPriorityArray;CalendarPlaylistPriorityArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarPlaylistPriorityArray[i]="";}
	delete CalendarPlaylistNameArray;CalendarPlaylistNameArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarPlaylistNameArray[i]="";}
	delete CalendarRelayURLArray;CalendarRelayURLArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarRelayURLArray[i]="";}
	delete CalendarRelayPriorityArray;CalendarRelayPriorityArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarRelayPriorityArray[i]="";}
	delete CalendarPerArray;CalendarPerArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarPerArray[i]="";}
	delete CalendarSunArray;CalendarSunArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarSunArray[i]="";}
	delete CalendarMonArray;CalendarMonArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarMonArray[i]="";}
	delete CalendarTueArray;CalendarTueArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarTueArray[i]="";}
	delete CalendarWedArray;CalendarWedArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarWedArray[i]="";}
	delete CalendarThuArray;CalendarThuArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarThuArray[i]="";}
	delete CalendarFriArray;CalendarFriArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarFriArray[i]="";}
	delete CalendarSatArray;CalendarSatArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarSatArray[i]="";}
	delete CalendarStartDateArray;CalendarStartDateArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarStartDateArray[i]="";}
	delete CalendarEndDateArray;CalendarEndDateArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarEndDateArray[i]="";}
	delete CalendarStartTimeArray;CalendarStartTimeArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarStartTimeArray[i]="";}
	delete CalendarDurationArray;CalendarDurationArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarDurationArray[i]="";}
	delete CalendarTimeOffsetArray;CalendarTimeOffsetArray = new Array(NumOfCalendarEvents);for(var i=0;i<NumOfCalendarEvents;i++){CalendarTimeOffsetArray[i]="";}
	EnableCapture=false;SetObjectValueID("EnableCaptureCheckBox",EnableCapture);
	CaptureDevice="";SetObjectValueID("CaptureDeviceInput",CaptureDevice);
	CaptureInput="";SetObjectValueID("CaptureInputInput",CaptureInput);
	CaptureSampleRate="44100";SetObjectValueID("CaptureSampleRateInput",CaptureSampleRate);
	CaptureNumChannels=2;SetObjectValueID("CaptureNumChannelsInput",CaptureNumChannels);
	ApplyReplayGain=false;SetObjectValueID("ApplyReplayGainCheckBox",ApplyReplayGain);
	DefaultReplayGain="0.0";SetObjectValueID("DefaultReplayGainInput",DefaultReplayGain);
	DJReplayGain="0.0";SetObjectValueID("DJReplayGainInput",DJReplayGain);
	CaptureReplayGain="0.0";SetObjectValueID("CaptureReplayGainInput",CaptureReplayGain);
	CalculateReplayGain=false;SetObjectValueID("CalculateReplayGainCheckBox",CalculateReplayGain);
	ReplayGainTempFolder="";SetObjectValueID("ReplayGainTempFolderInput",ReplayGainTempFolder);
	ReplayGainRunAhead=2;SetObjectValueID("ReplayGainRunAheadInput",ReplayGainRunAhead);
	ReplayGainDontWrite=false;SetObjectValueID("ReplayGainDontWriteCheckBox",ReplayGainDontWrite);
	EnhanceReplayGain="6.0";SetObjectValueID("EnhanceReplayGainInput",EnhanceReplayGain);
	MP3UnlockKeyName="";SetObjectValueID("MP3UnlockKeyNameInput",MP3UnlockKeyName);
	MP3UnlockKeyCode="";SetObjectValueID("MP3UnlockKeyCodeInput",MP3UnlockKeyCode);
	DefaultAuthHash="";SetObjectValueID("DefaultAuthHashInput",DefaultAuthHash);
	DNASConfigreWrite=false;SetObjectValueID("DNASConfigreWriteCheckBox",DNASConfigreWrite);
	TransConfigreWrite=false;SetObjectValueID("TransConfigreWriteCheckBox",TransConfigreWrite);
	DNASAdminPageTheme="v2";SetObjectValueID("DNASAdminPageThemeInput",DNASAdminPageTheme);
	TimeMultiplier=1;SetObjectValueID("TimeMultiplierInput",TimeMultiplier);
	DNASIntroFile="";SetObjectValueID("DNASIntroFileInput",DNASIntroFile);
	DNASBackupFile="";SetObjectValueID("DNASBackupFileInput",DNASBackupFile);
	DNASSpecialFileTmpDir="";SetObjectValueID("DNASSpecialFileTmpDirInput",DNASSpecialFileTmpDir);
	MaxSpecialFileSize=30000000;SetObjectValueID("MaxSpecialFileSizeInput",MaxSpecialFileSize);
	ServerBackupFile="";SetObjectValueID("ServerBackupFileInput",ServerBackupFile);
	ServerIntroFile="";SetObjectValueID("ServerIntroFileInput",ServerIntroFile);
	SongHistory=10;SetObjectValueID("SongHistoryInput",SongHistory);
}

var scscl="";
var sctcl="";
var scccl="";
var scssl="";
var sctsl="";
var scssfn="";
var sctsfn="";

var myScrollTable;
var lastHeight=0;
var HelperTable;
var HelperSpan;
var HelperXMLHTTP;
var HelperTextDBKeysArray;
var HelperTextDBValuesArray;

var SCServLinesTextArea;
var SCTransLinesTextArea;
var SCCalendarLinesTextArea;
var AddPlaylistButton;
var MultiPlaylistSpan;
var NumOfPlaylistsHidden;
var PlaylistMultiRemoveButtonArray = new Array(NumOfPlaylists);
var PlaylistMultiSymNameInputArray = new Array(NumOfPlaylists);
var PlaylistMultiCalendarAddButtonArray = new Array(NumOfPlaylists);
var PlaylistMultiFileInputArray = new Array(NumOfPlaylists);
var BufferTypeSelect;
var AdaptiveBufferSizeInput;
var AdaptiveBufferSizeTR;
var FixedBufferSizeTR;
var FixedBufferSizeInput;
var BufferHardLimitInput;
var MaxHeaderLineSizeInput;
var MaxHeaderLineCountInput;
var NameLookupsCheckBox;
var PlatformSelect;
var DNASBasePathInput;
var TranscoderBasePathInput;
var DNASConfFileInput;
var TransConfFileInput;
var ModeSelect;
var EnableLoggingCheckBox;
var ScreenlogCheckBox;
var DNASLogFileInput;
var TransLogFileInput;
var W3CLoggingCheckBox;
var W3CLogFileInput;
var WebClientDebugCheckBox;
var YP1DebugCheckBox;
var YP2DebugCheckBox;
var SHOUTcastSourceDebugCheckBox;
var UVOX2SourceDebugCheckBox;
var SHOUTcast1ClientDebugCheckBox;
var SHOUTcast2ClientDebugCheckBox;
var RelaySHOUTcastDebugCheckBox;
var RelayUVOXDebugCheckBox;
var RelayDebugCheckBox;
var StreamDataDebugCheckBox;
var HTTPStyleDebugCheckBox;
var StatsDebugCheckBox;
var MicroServerDebugCheckBox;
var ThreadRunnerDebugCheckBox;
var RTMPClientDebugCheckBox;
var ShuffleDebugCheckBox;
var SHOUTcastDebugCheckBox;
var UVOXDebugCheckBox;
var GainDebugCheckBox;
var PlaylistDebugCheckBox;
var MP3EncDebugCheckBox;
var MP3DecDebugCheckBox;
var ResamplerDebugCheckBox;
var RGCalcDebugCheckBox;
var APIDebugCheckBox;
var CalendarDebugCheckBox;
var CaptureDebugCheckBox;
var DJDebugCheckBox;
var FlashPolicyServerDebugCheckBox;
var FileConverterDebugCheckBox;
var SourceRelayDebugCheckBox;
var SourceAndEndpointManagerDebugCheckBox;
var StreamTitleInput;
var StreamURLInput;
var StreamGenreInput;
var AIMInput;
var IRCInput;
var ICQInput;
var UseMetadataCheckBox;
var MetadataPatternInput;
var DisplayMetadataPatternInput;
var TitleFormatInput;
var URLFormatInput;
var DNASPublicSelect;
var TransPublicCheckBox;
var MetaIntervalInput;
var YPAddrInput;
var YPPortInput;
var YPPathInput;
var YPTimeoutInput;
var YPMaxRetriesInput;
var YPReportIntervalInput;
var YPMinReportIntervalInput;
var PortBaseInput;
var DNASIPInput;
var ServerIPInput;
var SourceBindAddressInput;
var DestinationBindAddressInput;
var PasswordInput;
var AdminPasswordInput;
var VUImageDirectoryInput;
var VUImageSuffixInput;
var VUImageMimeTypeInput;
var DNASFlashPolicyFileInput;
var FlashPolicyFileInput;
var FlashPolicyServerPortInput;
var TransAdminPortInput;
var MP3UnlockKeyNameInput;
var MP3UnlockKeyCodeInput;
var DefaultAuthHashInput;
var BanFileInput;
var RipFileInput;
var RipOnlyCheckBox;
var MaxListenersInput;
var ListenerTimeInput;
var AutoDumpUsersCheckBox;
var CalendarFileInput;
var CalendarEnableRewriteCheckBox;
var NumOfCalendarEventsHidden;
var CalendarEventDeleteButtonArray = new Array(NumOfCalendarEvents);
var CalendarEventTypeSelectArray = new Array(NumOfCalendarEvents);
var CalendarDJNameInputArray = new Array(NumOfCalendarEvents);
var CalendarDJArchiveSelectArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistNameInputArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistLoopAtEndCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistShuffleSelectArray = new Array(NumOfCalendarEvents);
var CalendarPlaylistPriorityInputArray = new Array(NumOfCalendarEvents);
var CalendarRelayURLInputArray = new Array(NumOfCalendarEvents);
var CalendarRelayPriorityInputArray = new Array(NumOfCalendarEvents);
var CalendarPerCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarSunCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarMonCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarTueCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarWedCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarThuCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarFriCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarSatCheckBoxArray = new Array(NumOfCalendarEvents);
var CalendarStartDateInputArray = new Array(NumOfCalendarEvents);
var CalendarEndDateInputArray = new Array(NumOfCalendarEvents);
var CalendarStartTimeInputArray = new Array(NumOfCalendarEvents);
var CalendarDurationInputArray = new Array(NumOfCalendarEvents);
var CalendarTimeOffsetInputArray = new Array(NumOfCalendarEvents);
var CalendarEventAddButton;
var PlaylistFileInput;
var EnableShuffleCheckBox;
var XFadeTimeInput;
var XFadeThresholdInput;
var PlaylistFolderInput;
var PlaylistArchiveFolderInput;
var DJPortInput;
var DJPort2Input;
var DJCipherInput;
var DJAutoDumpSourceTimeInput;
var DJCaptureEnableCheckBox;
var DJBroadcastsPathInput;
var DJFilePatternInput;
var NumOfDJsHidden;
var DJLoginInputArray=new Array(NumOfDJs);
var DJPasswordInputArray=new Array(NumOfDJs);
var DJPriorityInputArray=new Array(NumOfDJs);
var DJCalendarAddButtonArray=new Array(NumOfDJs);
var DJDeleteButtonArray=new Array(NumOfDJs);
var DJAddButton;
var MultiDJSpan;
var EnableCaptureCheckBox;
var CaptureDeviceInput;
var CaptureInputInput;
var CaptureSampleRateInput;
var CaptureNumChannelsInput;
var ApplyReplayGainCheckBox;
var DefaultReplayGainInput;
var DJReplayGainInput;
var CaptureReplayGainInput;
var CalculateReplayGainCheckBox;
var ReplayGainTempFolderInput;
var ReplayGainRunAheadInput;
var ReplayGainDontWriteCheckBox;
var EnhanceReplayGainInput;
var NumOfEndPointsInput;
var DefaultAuthHashTR;
var NumOfEndPointsTR;
var EndPointPathInputArray=new Array(NumOfEndPoints);
var EndPointTypeSelectArray=new Array(NumOfEndPoints);
var EndPointAACFormatSelectArray=new Array(NumOfEndPoints);
var EndPointMP3QualitySelectArray=new Array(NumOfEndPoints);
var EndPointMP3ModeSelectArray=new Array(NumOfEndPoints);
var EndPointBitrateInputArray=new Array(NumOfEndPoints);
var EndPointSamplerateInputArray=new Array(NumOfEndPoints);
var EndPointNumchnsInputArray=new Array(NumOfEndPoints);
var EndPointAuthHashInputArray=new Array(NumOfEndPoints);
var EndPointNameInputArray=new Array(NumOfEndPoints);
var EndPointMaxUserInputArray = new Array(NumOfEndPoints);
var MultiPointSpan;
var MultiCalendarSpan;
var DNASConfigreWriteCheckBox;
var TransConfigreWriteCheckBox;
var DNASAdminPageThemeInput;
var TimeMultiplierInput;
var DNASIntroFileInput;
var DNASBackupFileInput;
var DNASSpecialFileTmpDirInput;
var MaxSpecialFileSizeInput;
var ServerBackupFileInput;
var ServerIntroFileInput;
var SongHistoryInput;
var ResetButton;
var DownloadConfigHelpButton;
var DownloadSCServHelpButton;
var DownloadSCTransHelpButton;
var DownloadCalendarHelpButton;
var DownloadDNASLaunchFileHelpButton;
var DownloadTransLaunchFileHelpButton;
var ConfigurationScrollTable;
var DNASDebugModeHidden;
var DNASDebugModeNoneRadio;
var DNASDebugModeAllRadio;
var DNASDebugModeCustomRadio;
var DNASDebugTable;
var TransDebugModeHidden;
var TransDebugModeNoneRadio;
var TransDebugModeAllRadio;
var TransDebugModeCustomRadio;
var TransDebugTable;


function MarryBasePathAndFile(BP,FN) {
	var t=new String(BP);
	var u=new String(FN);
	if(u.indexOf(":")>-1 || u.indexOf("%")>-1)return u;
	if(u.length>0) {
		if(u[0]==CPD && Platform!=1)return u;
	}
	var a=t.split(CPD);
	while(a[a.length-1]=="") {
		a.pop();
	}
	if(a.length<1)return u;
	var b=u.split(CPD);
	for(var i=0;i<b.length;i++) {
		if(b[i]==".") {
			b.shift();
			i--;
			continue;
		}
		if(b[i]=="..") {
			b.shift();
			a.pop();
			i--;
			continue;
		}
		a.push(b.shift());i--;
	}
	t=a.join(CPD);
	return t;
}

function DoPlatformSelectUpdate(ps) {
	switch(ps) {
		case 0://linux
			CPD=linuxPD;
		break;
		case 2://macintosh
			CPD=macintoshPD;
		break;
		default:
			CPD=windowsPD;
	}
	PushUpdateKill();
	RetoolPathDelimiters(DNASBasePathInput,CPD);
	RetoolPathDelimiters(TranscoderBasePathInput,CPD);
	RetoolPathDelimiters(DNASConfFileInput,CPD);
	RetoolPathDelimiters(TransConfFileInput,CPD);
	RetoolPathDelimiters(DNASLogFileInput,CPD);
	RetoolPathDelimiters(TransLogFileInput,CPD);
	RetoolPathDelimiters(W3CLogFileInput,CPD);
	RetoolPathDelimiters(VUImageDirectoryInput,CPD);
	RetoolPathDelimiters(DNASFlashPolicyFileInput,CPD);
	RetoolPathDelimiters(FlashPolicyFileInput,CPD);
	RetoolPathDelimiters(BanFileInput,CPD);
	RetoolPathDelimiters(RipFileInput,CPD);
	RetoolPathDelimiters(CalendarFileInput,CPD);
	RetoolPathDelimiters(PlaylistFileInput,CPD);
	RetoolPathDelimiters(PlaylistFolderInput,CPD);
	RetoolPathDelimiters(PlaylistArchiveFolderInput,CPD);
	RetoolPathDelimiters(DJBroadcastsPathInput,CPD);
	RetoolPathDelimiters(ReplayGainTempFolderInput,CPD);
	RetoolPathDelimiters(DNASIntroFileInput,CPD);
	RetoolPathDelimiters(DNASBackupFileInput,CPD);
	RetoolPathDelimiters(DNASSpecialFileTmpDirInput,CPD);
	RetoolPathDelimiters(ServerBackupFileInput,CPD);
	RetoolPathDelimiters(ServerIntroFileInput,CPD);
	for(var i=0;i<NumOfPlaylists;i++) {
		RetoolPathDelimiters(PlaylistMultiFileInputArray[i],CPD);
	}
	PopUpdateKill();
}

function DoBufferTypeUpdate(Type) {
	switch(Type) {
		case 0:
			AdaptiveBufferSizeTR.style.visibility="hidden";
			AdaptiveBufferSizeTR.style.display="none";
			FixedBufferSizeTR.style.visibility="";
			FixedBufferSizeTR.style.display="";
		break;
		case 1:
			AdaptiveBufferSizeTR.style.visibility="";
			AdaptiveBufferSizeTR.style.display="";
			FixedBufferSizeTR.style.visibility="hidden";
			FixedBufferSizeTR.style.display="none";
		break;
	}
}

function onBufferTypeSelectChanged() {
	BufferType=(BufferTypeSelect.value)*1;
	SetObjCookie(BufferTypeSelect);
	DoBufferTypeUpdate(BufferType);
	DoUpdate();
}

function onAdaptiveBufferSizeInputChanged() {
	AdaptiveBufferSize=(AdaptiveBufferSizeInput.value)*1;
	SetObjCookie(AdaptiveBufferSizeInput);
	DoUpdate();
}

function onFixedBufferSizeInputChanged() {
	FixedBufferSize=(FixedBufferSizeInput.value)*1;
	SetObjCookie(FixedBufferSizeInput);
	DoUpdate();
}

function onBufferHardLimitInputChanged() {
	BufferHardLimit=(BufferHardLimitInput.value)*1;
	SetObjCookie(BufferHardLimitInput);
	DoUpdate();
}

function onMaxHeaderLineSizeInputChanged() {
	MaxHeaderLineSize=(MaxHeaderLineSizeInput.value)*1;
	SetObjCookie(MaxHeaderLineSizeInput);
	DoUpdate();
}

function onMaxHeaderLineCountInputChanged() {
	MaxHeaderLineCount=(MaxHeaderLineCountInput.value)*1;
	SetObjCookie(MaxHeaderLineCountInput);
	DoUpdate();
}

function onNameLookupsCheckBoxClicked() {
	NameLookups=NameLookupsCheckBox.checked;
	SetObjCookie(NameLookupsCheckBox);
	DoUpdate();
}

function onPlatformSelectChanged() {
	Platform=(PlatformSelect.value)*1;
	SetObjCookie(PlatformSelect);
	DoPlatformSelectUpdate(Platform)
	DoUpdate();
}

function onDNASBasePathInputChanged() {
	DNASBasePath=DNASBasePathInput.value;
	SetObjCookie(DNASBasePathInput);
	DoUpdate();
}

function onTranscoderBasePathInputChanged() {
	TranscoderBasePath=TranscoderBasePathInput.value;
	SetObjCookie(TranscoderBasePathInput);
	DoUpdate();
}

function onDNASConfFileInputChanged() {
	DNASConfFile=(DNASConfFileInput.value);
	SetObjCookie(DNASConfFileInput);
	DoUpdate();
}

function onTransConfFileInputChanged() {
	TransConfFile=(TransConfFileInput.value);
	SetObjCookie(TransConfFileInput);
	DoUpdate();
}

function DoModeSelectUpdate(m) {
	switch(m) {
		case 1:
			NumOfEndPoints=1;
			NumOfEndPointsInput.onchange=null;
			NumOfEndPointsTR.style.visibility="hidden";
			NumOfEndPointsTR.style.display="none";
			DefaultAuthHashTR.style.visibility="hidden";
			DefaultAuthHashTR.style.display="none";
		break;
		default:
			NumOfEndPointsInput.onchange=null;
			NumOfEndPointsInput.value=NumOfEndPoints;
			NumOfEndPoints=GetObjCookie(NumOfEndPointsInput);
			NumOfEndPointsInput.onchange=onNumOfEndPointsInputChanged;
			NumOfEndPointsTR.style.visibility="";
			NumOfEndPointsTR.style.display="";
			DefaultAuthHashTR.style.visibility="";
			DefaultAuthHashTR.style.display="";
			NumOfEndPoints=(NumOfEndPointsInput.value)*1;
	}
}

function onModeSelectChanged() {
	var m=Mode;
	Mode=(ModeSelect.value)*1;
	SetObjCookie(ModeSelect);
	if(m!=Mode) {
		DoModeSelectUpdate(Mode);
		MultiPointSpanUpdate(NumOfEndPoints);
		DoUpdate();
	}
}

function onEnableLoggingCheckBoxClicked() {
	EnableLogging=EnableLoggingCheckBox.checked;
	SetObjCookie(EnableLoggingCheckBox);
	DoUpdate();
}

function onScreenlogCheckBoxClicked() {
	Screenlog=ScreenlogCheckBox.checked;
	SetObjCookie(ScreenlogCheckBox);
	DoUpdate();
}

function onDNASLogFileInputChanged() {
	DNASLogFile=DNASLogFileInput.value;
	SetObjCookie(DNASLogFileInput);
	DoUpdate();
}

function onTransLogFileInputChanged() {
	TransLogFile=TransLogFileInput.value;
	SetObjCookie(TransLogFileInput);
	DoUpdate();
}

function onW3CLoggingCheckBoxClicked() {
	W3CLogging=W3CLoggingCheckBox.checked;
	SetObjCookie(W3CLoggingCheckBox);
	DoUpdate();
}

function onW3CLogFileInputChanged() {
	W3CLogFile=W3CLogFileInput.value;
	SetObjCookie(W3CLogFileInput);
	DoUpdate();
}

function onWebClientDebugCheckBoxClicked() {
	WebClientDebug=(WebClientDebugCheckBox.checked);
	SetObjCookie(WebClientDebugCheckBox);
	DoUpdate();
}

function onYP1DebugCheckBoxClicked() {
	YP1Debug=YP1DebugCheckBox.checked;
	SetObjCookie(YP1DebugCheckBox);
	DoUpdate();
}

function onYP2DebugCheckBoxClicked() {
	YP2Debug=YP2DebugCheckBox.checked;
	SetObjCookie(YP2DebugCheckBox);
	DoUpdate();
}

function onSHOUTcastSourceDebugCheckBoxClicked() {
	SHOUTcastSourceDebug=SHOUTcastSourceDebugCheckBox.checked;
	SetObjCookie(SHOUTcastSourceDebugCheckBox);
	DoUpdate();
}

function onUVOX2SourceDebugCheckBoxClicked() {
	UVOX2SourceDebug=UVOX2SourceDebugCheckBox.checked;
	SetObjCookie(UVOX2SourceDebugCheckBox);
	DoUpdate();
}

function onSHOUTcast1ClientDebugCheckBoxClicked() {
	SHOUTcast1ClientDebug=SHOUTcast1ClientDebugCheckBox.checked;
	SetObjCookie(SHOUTcast1ClientDebugCheckBox);
	DoUpdate();
}

function onSHOUTcast2ClientDebugCheckBoxClicked() {
	SHOUTcast2ClientDebug=SHOUTcast2ClientDebugCheckBox.checked;
	SetObjCookie(SHOUTcast2ClientDebugCheckBox);
	DoUpdate();
}

function onRelaySHOUTcastDebugCheckBoxClicked() {
	RelaySHOUTcastDebug=RelaySHOUTcastDebugCheckBox.checked;
	SetObjCookie(RelaySHOUTcastDebugCheckBox);
	DoUpdate();
}

function onRelayUVOXDebugCheckBoxClicked() {
	RelayUVOXDebug=RelayUVOXDebugCheckBox.checked;
	SetObjCookie(RelayUVOXDebugCheckBox);
	DoUpdate();
}

function onRelayDebugCheckBoxClicked() {
	RelayDebug=RelayDebugCheckBox.checked;
	SetObjCookie(RelayDebugCheckBox);
	DoUpdate();
}

function onStreamDataDebugCheckBoxClicked() {
	StreamDataDebug=StreamDataDebugCheckBox.checked;
	SetObjCookie(StreamDataDebugCheckBox);
	DoUpdate();
}

function onHTTPStyleDebugCheckBoxClicked() {
	HTTPStyleDebug=HTTPStyleDebugCheckBox.checked;
	SetObjCookie(HTTPStyleDebugCheckBox);
	DoUpdate();
}

function onStatsDebugCheckBoxClicked() {
	StatsDebug=StatsDebugCheckBox.checked;
	SetObjCookie(StatsDebugCheckBox);
	DoUpdate();
}

function onMicroServerDebugCheckBoxClicked() {
	MicroServerDebug=MicroServerDebugCheckBox.checked;
	SetObjCookie(MicroServerDebugCheckBox);
	DoUpdate();
}

function onThreadRunnerDebugCheckBoxClicked() {
	ThreadRunnerDebug=ThreadRunnerDebugCheckBox.checked;
	SetObjCookie(ThreadRunnerDebugCheckBox);
	DoUpdate();
}

function onRTMPClientDebugCheckBoxClicked() {
	RTMPClientDebug=RTMPClientDebugCheckBox.checked;
	SetObjCookie(RTMPClientDebugCheckBox);
	DoUpdate();
}

function DoDNASDebugModeUpdate(m) {

	switch(m) {
		case 0:
		case 1:
		DNASDebugTable.style.visibility="hidden";
		DNASDebugTable.style.display="none";
		break;
		default:
		DNASDebugTable.style.visibility="";
		DNASDebugTable.style.display="";
		break;
	}
	switch(m) {
		case 0:
		DNASDebugModeNoneRadio.checked=true;
		break;
		case 1:
		DNASDebugModeAllRadio.checked=true;
		break;
		case 2:
		DNASDebugModeCustomRadio.checked=true;
		break;
	}
}

function onDNASDebugModeHiddenChanged() {
	var m=(DNASDebugModeHidden.value)*1;
	if(DNASDebugMode!=m) {
		DNASDebugMode=m;
		SetObjCookie(DNASDebugModeHidden);
		DoDNASDebugModeUpdate(m);
		DoUpdate();
	}
}

function onDNASDebugModeNoneRadioClicked() {
	DNASDebugModeHidden.value=(DNASDebugModeNoneRadio.value)*1;
	CallObjectChanged(DNASDebugModeHidden);
}

function onDNASDebugModeAllRadioClicked() {
	DNASDebugModeHidden.value=(DNASDebugModeAllRadio.value)*1;
	CallObjectChanged(DNASDebugModeHidden);
}

function onDNASDebugModeCustomRadioClicked() {
	DNASDebugModeHidden.value=(DNASDebugModeCustomRadio.value)*1;
	CallObjectChanged(DNASDebugModeHidden);
}

function DoTransDebugModeUpdate(m) {

	switch(m) {
		case 0:
		case 1:
		TransDebugTable.style.visibility="hidden";
		TransDebugTable.style.display="none";
		break;
		default:
		TransDebugTable.style.visibility="";
		TransDebugTable.style.display="";
		break;
	}
	switch(m) {
		case 0:
		TransDebugModeNoneRadio.checked=true;
		break;
		case 1:
		TransDebugModeAllRadio.checked=true;
		break;
		case 2:
		TransDebugModeCustomRadio.checked=true;
		break;
	}
}

function onTransDebugModeHiddenChanged() {
	var m=(TransDebugModeHidden.value)*1;
	if(TransDebugMode!=m) {
		TransDebugMode=m;
		SetObjCookie(TransDebugModeHidden);
		DoTransDebugModeUpdate(m);
		DoUpdate();
	}
}

function onTransDebugModeNoneRadioClicked() {
	TransDebugModeHidden.value=(TransDebugModeNoneRadio.value)*1;
	CallObjectChanged(TransDebugModeHidden);
}

function onTransDebugModeAllRadioClicked() {
	TransDebugModeHidden.value=(TransDebugModeAllRadio.value)*1;
	CallObjectChanged(TransDebugModeHidden);
}

function onTransDebugModeCustomRadioClicked() {
	TransDebugModeHidden.value=(TransDebugModeCustomRadio.value)*1;
	CallObjectChanged(TransDebugModeHidden);
}

function onShuffleDebugCheckBoxClicked() {
	ShuffleDebug=ShuffleDebugCheckBox.checked;
	SetObjCookie(ShuffleDebugCheckBox);
	DoUpdate();
}

function onSHOUTcastDebugCheckBoxClicked() {
	SHOUTcastDebug=SHOUTcastDebugCheckBox.checked;
	SetObjCookie(SHOUTcastDebugCheckBox);
	DoUpdate();
}

function onUVOXDebugCheckBoxClicked() {
	UVOXDebug=UVOXDebugCheckBox.checked;
	SetObjCookie(UVOXDebugCheckBox);
	DoUpdate();
}

function onGainDebugCheckBoxClicked() {
	GainDebug=GainDebugCheckBox.checked;
	SetObjCookie(GainDebugCheckBox);
	DoUpdate();
}

function onPlaylistDebugCheckBoxClicked() {
	PlaylistDebug=PlaylistDebugCheckBox.checked;
	SetObjCookie(PlaylistDebugCheckBox);
	DoUpdate();
}

function onMP3EncDebugCheckBoxClicked() {
	MP3EncDebug=MP3EncDebugCheckBox.checked;
	SetObjCookie(MP3EncDebugCheckBox);
	DoUpdate();
}

function onMP3DecDebugCheckBoxClicked() {
	MP3DecDebug=MP3DecDebugCheckBox.checked;
	SetObjCookie(MP3DecDebugCheckBox);
	DoUpdate();
}

function onResamplerDebugCheckBoxClicked() {
	ResamplerDebug=ResamplerDebugCheckBox.checked;
	SetObjCookie(ResamplerDebugCheckBox);
	DoUpdate();
}

function onRGCalcDebugCheckBoxClicked() {
	RGCalcDebug=RGCalcDebugCheckBox.checked;
	SetObjCookie(RGCalcDebugCheckBox);
	DoUpdate();
}

function onAPIDebugCheckBoxClicked() {
	APIDebug=APIDebugCheckBox.checked;
	SetObjCookie(APIDebugCheckBox);
	DoUpdate();
}
 
function onCalendarDebugCheckBoxClicked() {
	CalendarDebug=CalendarDebugCheckBox.checked;
	SetObjCookie(CalendarDebugCheckBox);
	DoUpdate();
}

function onCaptureDebugCheckBoxClicked() {
	CaptureDebug=CaptureDebugCheckBox.checked;
	SetObjCookie(CaptureDebugCheckBox);
	DoUpdate();
}
 
function onDJDebugCheckBoxClicked() {
	DJDebug=DJDebugCheckBox.checked;
	SetObjCookie(DJDebugCheckBox);
	DoUpdate();
}

function onFlashPolicyServerDebugCheckBoxClicked() {
	FlashPolicyServerDebug=FlashPolicyServerDebugCheckBox.checked;
	SetObjCookie(FlashPolicyServerDebugCheckBox);
	DoUpdate();
}

function onFileConverterDebugCheckBoxClicked() {
	FileConverterDebug=FileConverterDebugCheckBox.checked;
	SetObjCookie(FileConverterDebugCheckBox);
	DoUpdate();
}

function onSourceRelayDebugCheckBoxClicked() {
	SourceRelayDebug=SourceRelayDebugCheckBox.checked;
	SetObjCookie(SourceRelayDebugCheckBox);
	DoUpdate();
}

function onSourceAndEndpointManagerDebugCheckBoxClicked() {
	SourceAndEndpointManagerDebug=SourceAndEndpointManagerDebugCheckBox.checked;
	SetObjCookie(SourceAndEndpointManagerDebugCheckBox);
	DoUpdate();
}

function onStreamTitleInputChanged() {
	StreamTitle=StreamTitleInput.value;
	SetObjCookie(StreamTitleInput);
	DoUpdate();
}

function onStreamURLInputChanged() {
	StreamURL=StreamURLInput.value;
	SetObjCookie(StreamURLInput);
	DoUpdate();
}

function onStreamGenreInputChanged() {
	StreamGenre=StreamGenreInput.value;
	SetObjCookie(StreamGenreInput);
	DoUpdate();
}

function onAIMInputChanged() {
	AIM=AIMInput.value;
	SetObjCookie(AIMInput);
	DoUpdate();
}

function onIRCInputChanged() {
	IRC=IRCInput.value;
	SetObjCookie(IRCInput);
	DoUpdate();
}

function onICQInputChanged() {
	ICQ=ICQInput.value;
	SetObjCookie(ICQInput);
	DoUpdate();
}

function onUseMetadataCheckBoxClicked() {
	UseMetadata=UseMetadataCheckBox.checked;
	SetObjCookie(UseMetadataCheckBox);
	DoUpdate();
}

function onMetadataPatternInputChanged() {
	MetadataPattern=MetadataPatternInput.value;
	SetObjCookie(MetadataPatternInput);
	DoUpdate();
}

function onDisplayMetadataPatternInputChanged() {
	DisplayMetadataPattern=DisplayMetadataPatternInput.value;
	SetObjCookie(DisplayMetadataPatternInput);
	DoUpdate();
}

function onTitleFormatInputChanged() {
	TitleFormat=TitleFormatInput.value;
	SetObjCookie(TitleFormatInput);
	DoUpdate();
}

function onURLFormatInputChanged() {
	URLFormat=URLFormatInput.value;
	SetObjCookie(URLFormatInput);
	DoUpdate();
}

function onDNASPublicSelectChanged() {
	DNASPublic=DNASPublicSelect.value;
	SetObjCookie(DNASPublicSelect);
	DoUpdate();
}

function onTransPublicCheckBoxClicked() {
	SCTransPublic=TransPublicCheckBox.checked;
	SetObjCookie(TransPublicCheckBox);
	DoUpdate();
}

function onMetaIntervalInputChanged() {
	MetaInterval=(MetaIntervalInput.value)*1;
	SetObjCookie(MetaIntervalInput);
	DoUpdate();
}

function onYPAddrInputChanged() {
	YPAddr=YPAddrInput.value;
	SetObjCookie(YPAddrInput);
	DoUpdate();
}

function onYPPortInputChanged() {
	YPPort=(YPPortInput.value)*1;
	SetObjCookie(YPPortInput);
	DoUpdate();
}

function onYPPathInputChanged() {
	YPPath=YPPathInput.value;
	SetObjCookie(YPPathInput);
	DoUpdate();
}

function onYPTimeoutInputChanged() {
	YPTimeout=(YPTimeoutInput.value)*1;
	SetObjCookie(YPTimeoutInput);
	DoUpdate();
}

function onYPMaxRetriesInputChanged() {
	YPMaxRetries=(YPMaxRetriesInput.value)*1;
	SetObjCookie(YPMaxRetriesInput);
	DoUpdate();
}

function onYPReportIntervalInputChanged() {
	YPReportInterval=(YPReportIntervalInput.value)*1;
	SetObjCookie(YPReportIntervalInput);
	DoUpdate();
}

function onYPMinReportIntervalInputChanged() {
	YPMinReportInterval=(YPMinReportIntervalInput.value)*1;
	SetObjCookie(YPMinReportIntervalInput);
	DoUpdate();
}

function onPortBaseInputChanged() {
	PortBase=PortBaseInput.value;
	SetObjCookie(PortBaseInput);
	DoUpdate();
}

function onDNASIPInputChanged() {
	DNASIP=DNASIPInput.value;
	SetObjCookie(DNASIPInput);
	DoUpdate();
}


function onSourceBindAddressInputChanged() {
	SourceBindAddress=SourceBindAddressInput.value;
	SetObjCookie(SourceBindAddressInput);
	DoUpdate();
}

function onDestinationBindAddressInputChanged() {
	DestinationBindAddress=DestinationBindAddressInput.value;
	SetObjCookie(DestinationBindAddressInput);
	DoUpdate();
}

function onTransAdminPortInputChanged() {
	TransAdminPort=(TransAdminPortInput.value)*1;
	SetObjCookie(TransAdminPortInput);
	DoUpdate();
}

function onPasswordInputChanged() {
	Password=PasswordInput.value;
	SetObjCookie(PasswordInput);
	DoUpdate();
}

function onAdminPasswordInputChanged() {
	AdminPassword=AdminPasswordInput.value;
	SetObjCookie(AdminPasswordInput);
	DoUpdate();
}

function onVUImageDirectoryInputChanged() {
	VUImageDirectory=VUImageDirectoryInput.value;
	SetObjCookie(VUImageDirectoryInput);
	DoUpdate();
}

function onVUImageSuffixInputChanged() {
	VUImageSuffix=VUImageSuffixInput.value;
	SetObjCookie(VUImageSuffixInput);
	DoUpdate();
}

function onVUImageMimeTypeInputChanged() {
	VUImageMimeType=VUImageMimeTypeInput.value;
	SetObjCookie(VUImageMimeTypeInput);
	DoUpdate();
}

function onDNASFlashPolicyFileInputChanged() {
	DNASFlashPolicyFile=DNASFlashPolicyFileInput.value;
	SetObjCookie(DNASFlashPolicyFileInput);
	DoUpdate();
}

function onFlashPolicyFileInputChanged() {
	FlashPolicyFile=FlashPolicyFileInput.value;
	SetObjCookie(FlashPolicyFileInput);
	DoUpdate();
}

function onFlashPolicyServerPortInputChanged() {
	FlashPolicyServerPort=(FlashPolicyServerPortInput.value)*1;
	SetObjCookie(FlashPolicyServerPortInput);
	DoUpdate();
}

function onMP3UnlockKeyNameInputChanged() {
	MP3UnlockKeyName=MP3UnlockKeyNameInput.value;
	SetObjCookie(MP3UnlockKeyNameInput);
	DoUpdate();
}

function onMP3UnlockKeyCodeInputChanged() {
	MP3UnlockKeyCode=MP3UnlockKeyCodeInput.value;
	SetObjCookie(MP3UnlockKeyCodeInput);
	DoUpdate();
}

function onDefaultAuthHashInputChanged() {
	DefaultAuthHash=(DefaultAuthHashInput.value);
	SetObjCookie(DefaultAuthHashInput);
	DoUpdate();
}

function onBanFileInputChanged() {
	BanFile=BanFileInput.value;
	SetObjCookie(BanFileInput);
	DoUpdate();
}

function onRipFileInputChanged() {
	RipFile=RipFileInput.value;
	SetObjCookie(RipFileInput);
	DoUpdate();
}

function onRipOnlyCheckBoxClicked() {
	RipOnly=RipOnlyCheckBox.checked;
	SetObjCookie(RipOnlyCheckBox);
	DoUpdate();
}

function onMaxListenersInputChanged() {
	MaxListeners=MaxListenersInput.value;
	SetObjCookie(MaxListenersInput);
	DoUpdate();
}

function onListenerTimeInputChanged() {
	ListenerTime=(ListenerTimeInput.value)*1;
	SetObjCookie(ListenerTimeInput);
	DoUpdate();
}

function onAutoDumpUsersCheckBoxClicked() {
	AutoDumpUsers=AutoDumpUsersCheckBox.checked;
	SetObjCookie(AutoDumpUsersCheckBox);
	DoUpdate();
}

function onCalendarFileInputChanged() {
	CalendarFile=CalendarFileInput.value;
	SetObjCookie(CalendarFileInput);
	DoUpdate();
}

function onCalendarEnableRewriteCheckBoxClicked() {
	CalendarEnableRewrite=CalendarEnableRewriteCheckBox.checked;
	SetObjCookie(CalendarEnableRewriteCheckBox);
	DoUpdate();
}

function onPlaylistFileInputChanged() {
	PlaylistFile=PlaylistFileInput.value;
	SetObjCookie(PlaylistFileInput);
	DoUpdate();
}
 
function onEnableShuffleCheckBoxClicked() {
	EnableShuffle=EnableShuffleCheckBox.checked;
	SetObjCookie(EnableShuffleCheckBox);
	DoUpdate();
}

function onXFadeTimeInputChanged() {
	XFadeTime=(XFadeTimeInput.value)*1;
	SetObjCookie(XFadeTimeInput);
	DoUpdate();
}

function onXFadeThresholdInputChanged() {
	XFadeThreshold=XFadeThresholdInput.value;
	SetObjCookie(XFadeThresholdInput);
	DoUpdate();
}

function onPlaylistFolderInputChanged() {
	PlaylistFolder=PlaylistFolderInput.value;
	SetObjCookie(PlaylistFolderInput);
	DoUpdate();
}

function onPlaylistArchiveFolderInputChanged() {
	PlaylistArchiveFolder=PlaylistArchiveFolderInput.value;
	SetObjCookie(PlaylistArchiveFolderInput);
	DoUpdate();
}

function onDJPortInputChanged() {
	DJPort=(DJPortInput.value)*1;
	SetObjCookie(DJPortInput);
	DoUpdate();
}

function onDJPort2InputChanged() {
	DJPort2=(DJPort2Input.value)*1;
	SetObjCookie(DJPort2Input);
	DoUpdate();
}

function onDJCipherInputChanged() {
	DJCipher=DJCipherInput.value;
	SetObjCookie(DJCipherInput);
	DoUpdate();
}

function onDJAutoDumpSourceTimeInputChanged() {
	DJAutoDumpSourceTime=(DJAutoDumpSourceTimeInput.value)*1;
	SetObjCookie(DJAutoDumpSourceTimeInput);
	DoUpdate();
}

function onDJCaptureEnableCheckBoxClicked() {
	DJCaptureEnable=DJCaptureEnableCheckBox.checked;
	SetObjCookie(DJCaptureEnableCheckBox);
	DoUpdate();
}

function onDJBroadcastsPathInputChanged() {
	DJBroadcastsPath=DJBroadcastsPathInput.value;
	SetObjCookie(DJBroadcastsPathInput);
	DoUpdate();
}

function onDJFilePatternInputChanged() {
	DJFilePattern=DJFilePatternInput.value;
	SetObjCookie(DJFilePatternInput);
	DoUpdate();
} 

function onNumOfDJsHiddenChanged() {
	NumOfDJs=(NumOfDJsHidden.value)*1;
	SetObjCookie(NumOfDJsHidden);
	MultiDJSpanUpdate();
	DoUpdate();
}

function onDJLoginInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=DJLoginInputArray.indexOf(obj)
	if(i<0)return;
	var OldDJLogin=DJLoginArray[i];
	DJLoginArray[i]=(DJLoginInputArray[i].value);
	SetObjCookie(DJLoginInputArray[i]);
	var NewDJLogin=DJLoginArray[i];
	if(OldDJLogin!=NewDJLogin) {
		for(var i=0;i<NumOfCalendarEvents;i++) {
			if(CalendarDJNameArray[i]==OldDJLogin) {
				CalendarDJNameArray[i]=NewDJLogin;
				SetObjectValue(CalendarDJNameInputArray[i],NewDJLogin);
				SetObjCookie(CalendarDJNameInputArray[i]);
				PushUpdateKill();
				CallObjectChanged(CalendarDJNameInputArray[i]);
				PopUpdateKill();
			}
		}
		DoUpdate();
	}
}

function onDJPasswordInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=DJPasswordInputArray.indexOf(obj)
	if(i<0)return;
	DJPasswordArray[i]=(DJPasswordInputArray[i].value);
	SetObjCookie(DJPasswordInputArray[i]);
	DoUpdate();
}

function onDJPriorityInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=DJPriorityInputArray.indexOf(obj)
	if(i<0)return;
	DJPriorityArray[i]=(DJPriorityInputArray[i].value);
	SetObjCookie(DJPriorityInputArray[i]);
	DoUpdate();
}

function onDJCalendarAddButtonClicked(w)
{
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var dji=DJCalendarAddButtonArray.indexOf(obj);
	var DJLoginObj=DJLoginInputArray[dji];
	if(DJLoginObj==null || DJLoginObj==undefined)return;
	if(DJLoginObj.value=="")return;
	DoAddCalendarEvent();
	DoUpdate();
	var CalEvtTypeObj=CalendarEventTypeSelectArray[NumOfCalendarEvents-1];
	var CalDJNameObj=CalendarDJNameInputArray[NumOfCalendarEvents-1];
	if(CalDJNameObj!=null && CalDJNameObj!=undefined && CalEvtTypeObj!=null && CalEvtTypeObj!=undefined) {
		if(dji>-1)
		{
			PushUpdateKill();
			SetObjectValue(CalEvtTypeObj,"dj");
			CallObjectChanged(CalEvtTypeObj);
			SetObjectValue(CalDJNameObj,DJLoginObj.value);
			CallObjectChanged(CalDJNameObj);
			PopUpdateKill();
			DoUpdate();
			alert("The DJ has been added to the Calendar event list.  Double check the name matches and to set the desired run-time(s).");
		}
	}
}

function onDJDeleteButtonClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	DoDeleteDJ(obj);
	DoUpdate();
}

function onDJAddButtonClicked() {
	// check so that we only add in more djs if the last attempt was ok
	if(!NumOfDJs || DJLoginInputArray[NumOfDJs-1].value) {
		DoAddDJ();
		DoUpdate();
	}
}

function onEnableCaptureCheckBoxClicked() {
	EnableCapture=EnableCaptureCheckBox.checked;
	SetObjCookie(EnableCaptureCheckBox);
	DoUpdate();
}

function onCaptureDeviceInputChanged() {
	CaptureDevice=CaptureDeviceInput.value;
	SetObjCookie(CaptureDeviceInput);
	DoUpdate();
}

function onCaptureInputInputChanged() {
	CaptureInput=CaptureInputInput.value;
	SetObjCookie(CaptureInputInput);
	DoUpdate();
}

function onCaptureSampleRateInputChanged() {
	CaptureSampleRate=CaptureSampleRateInput.value;
	SetObjCookie(CaptureSampleRateInput);
	DoUpdate();
}

function onCaptureNumChannelsInputChanged() {
	CaptureNumChannels=CaptureNumChannelsInput.value;
	SetObjCookie(CaptureNumChannelsInput);
	DoUpdate();
}

function onApplyReplayGainCheckBoxClicked() {
	ApplyReplayGain=ApplyReplayGainCheckBox.checked;
	SetObjCookie(ApplyReplayGainCheckBox);
	DoUpdate();
}

function onDefaultReplayGainInputChanged() {
	DefaultReplayGain=DefaultReplayGainInput.value;
	SetObjCookie(DefaultReplayGainInput);
	DoUpdate();
}

function onDJReplayGainInputChanged() {
	DJReplayGain=DJReplayGainInput.value;
	SetObjCookie(DJReplayGainInput);
	DoUpdate();
}

function onCaptureReplayGainInputChanged() {
	CaptureReplayGain=CaptureReplayGainInput.value;
	SetObjCookie(CaptureReplayGainInput);
	DoUpdate();
}

function onCalculateReplayGainCheckBoxClicked() {
	CalculateReplayGain=CalculateReplayGainCheckBox.checked;
	SetObjCookie(CalculateReplayGainCheckBox);
	DoUpdate();
}

function onReplayGainTempFolderInputChanged() {
	ReplayGainTempFolder=ReplayGainTempFolderInput.value;
	SetObjCookie(ReplayGainTempFolderInput);
	DoUpdate();
}

function onReplayGainRunAheadInputChanged() {
	ReplayGainRunAhead=ReplayGainRunAheadInput.value;
	SetObjCookie(ReplayGainRunAheadInput);
	DoUpdate();
}

function onReplayGainDontWriteCheckBoxClicked() {
	ReplayGainDontWrite=ReplayGainDontWriteCheckBox.checked;
	SetObjCookie(ReplayGainDontWriteCheckBox);
	DoUpdate();
}

function onEnhanceReplayGainInputChanged() {
	EnhanceReplayGain=EnhanceReplayGainInput.value;
	SetObjCookie(EnhanceReplayGainInput);
	DoUpdate();
}

function onNumOfEndPointsInputChanged() {
	var w=(NumOfEndPoints)*1;
	NumOfEndPoints=(NumOfEndPointsInput.value)*1;
	SetObjCookie(NumOfEndPointsInput);
	if(w!=NumOfEndPoints) {
		MultiPointSpanUpdate(NumOfEndPoints);
		DoUpdate();
	}
}

function DoEndPointTypeSelectUpdate(obj) {
	var i=EndPointTypeSelectArray.indexOf(obj);
	var y=document.getElementById("EndPoint"+(i+1)+"MP3FormatSpan");
	if(obj.value!="mp3") {
			y.style.visibility="hidden";
			y.style.display="none";
	}
	else {
		y.style.visibility="visible";
		y.style.display="block";
	}
	var y=document.getElementById("EndPoint"+(i+1)+"AACFormatSpan");
	if(obj.value!="aacp") {
		y.style.visibility="hidden";
		y.style.display="none";
	}
	else {
		y.style.visibility="visible";
		y.style.display="block";
	}
}

function onEndPointTypeSelectChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	SetObjCookie(obj);
	DoEndPointTypeSelectUpdate(obj);
	DoUpdate();
}

function onEndPointGenericObjectChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	SetObjCookie(obj);
	DoUpdate();
}

function onDNASConfigreWriteCheckBoxClicked() {
	DNASConfigreWrite=DNASConfigreWriteCheckBox.checked;
	SetObjCookie(DNASConfigreWriteCheckBox);
	DoUpdate();
}

function onTransConfigreWriteCheckBoxClicked() {
	TransConfigreWrite=TransConfigreWriteCheckBox.checked;
	SetObjCookie(TransConfigreWriteCheckBox);
	DoUpdate();
}

function onDNASAdminPageThemeInputChanged() {
	DNASAdminPageTheme=DNASAdminPageThemeInput.value;
	SetObjCookie(DNASAdminPageThemeInput);
	DoUpdate();
}

function onTimeMultiplierInputChanged() {
	TimeMultiplier=(TimeMultiplierInput.value)*1;
	SetObjCookie(TimeMultiplierInput);
	DoUpdate();
}

function onDNASIntroFileInputChanged() {
	DNASIntroFile=DNASIntroFileInput.value;
	SetObjCookie(DNASIntroFileInput);
	DoUpdate();
}

function onDNASBackupFileInputChanged() {
	DNASBackupFile=DNASBackupFileInput.value;
	SetObjCookie(DNASBackupFileInput);
	DoUpdate();
}

function onDNASSpecialFileTmpDirInputChanged() {
	DNASSpecialFileTmpDir=DNASSpecialFileTmpDirInput.value;
	SetObjCookie(DNASSpecialFileTmpDirInput);
	DoUpdate();
}

function onMaxSpecialFileSizeInputChanged() {
	MaxSpecialFileSize=(MaxSpecialFileSizeInput.value)*1;
	SetObjCookie(MaxSpecialFileSizeInput);
	DoUpdate();
}

function onServerBackupFileInputChanged() {
	ServerBackupFile=ServerBackupFileInput.value;
	SetObjCookie(ServerBackupFileInput);
	DoUpdate();
}

function onServerIntroFileInputChanged() {
	ServerIntroFile=ServerIntroFileInput.value;
	SetObjCookie(ServerIntroFileInput);
	DoUpdate();
}

function onSongHistoryInputChanged() {
	SongHistory=SongHistoryInput.value;
	SetObjCookie(SongHistoryInput);
	DoUpdate();
}

function DoAddPlaylist() {
	// check so that we only add in more playlists if the last attempt was ok
	if(!NumOfPlaylists || PlaylistMultiSymNameInputArray[NumOfPlaylists-1].value) {
		NumOfPlaylists++;
		NumOfPlaylistsHidden.value=NumOfPlaylists;
		SetObjCookie(NumOfPlaylistsHidden);
		MultiPlaylistSpanUpdate();
	}
}

function onAddPlaylistButtonClicked() {
	DoAddPlaylist();
}

function onNumOfPlaylistsHiddenChanged() {
	NumOfPlaylists=(NumOfPlaylistsHidden.value)*1;
	SetObjCookie(NumOfPlaylistsHidden);
	MultiPlaylistSpanUpdate();
	DoUpdate();
}

function onResetButtonClicked() {
	deleteAllCookies();
	DoInit();
}

function bts(p){
	if(p){
		return "1";
	}
	return "0";
}

function DoUpdate() {
	if(KillDoUpdate)return;
	PushUpdateKill();

	scssl="";
	sctsl="";

	var NL;
	var DNASBinary="";
	var TransBinary="";
	var scsbps="";
	var sctbps="";
	switch(Platform*1) {
		case 0:
			NL=linux;
		break;
		case 2:
			NL=macintosh;
		break;
		default:
			NL=windows;
	}
	switch(Platform*1) {
		case 0:
		case 2:
			scssfn="start_sc_serv.sh";
			sctsfn="start_sc_trans.sh";
			scssl+="# DNAS startup shell script built with the SHOUTcast 2 Configuration Builder"+NL;
			sctsl+="# Transcoder startup shell script built with the SHOUTcast 2 Configuration Builder"+NL;
			DNASBinary="sc_serv";
			TransBinary="sc_trans";
			if(DNASBasePath.length>0) {
				if(DNASBasePath[0]!=CPD) {
					scsbps="."+CPD;
				}
			}
			else {
					scsbps="."+CPD;
			}
			if(TranscoderBasePath.length>0) {
				if(TranscoderBasePath[0]!=CPD) {
					sctbps="."+CPD;
				}
			}
			else {
					sctbps="."+CPD;
			}
		break;
		default:
			scssfn="start_sc_serv.bat";
			sctsfn="start_sc_trans.bat";
			scssl+="REM DNAS startup batch file built with the SHOUTcast 2 Configuration Builder"+NL;
			sctsl+="REM Transcoder startup batch file built with the SHOUTcast 2 Configuration Builder"+NL;
			DNASBinary="sc_serv.exe";
			TransBinary="sc_trans.exe";
	}
	scscl=";DNAS configuration file built with the SHOUTcast 2 Configuration Builder"+NL+NL;
	sctcl=";Transcoder configuration file built with the SHOUTcast 2 Configuration Builder"+NL+NL;
	scccl="<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+NL+"<!--Calendar configuration file built with the SHOUTcast 2 Configuration Builder-->"+NL;

	scssl+="\""+scsbps+MarryBasePathAndFile(DNASBasePath,DNASBinary)+"\" \""+scsbps+MarryBasePathAndFile(DNASBasePath,DNASConfFile)+"\""+NL;
	sctsl+="\""+sctbps+MarryBasePathAndFile(TranscoderBasePath,TransBinary)+"\" \""+sctbps+MarryBasePathAndFile(TranscoderBasePath,TransConfFile)+"\""+NL;

	scscl+="configrewrite="+bts(DNASConfigreWrite)+NL;
	sctcl+="configrewrite="+bts(TransConfigreWrite)+NL;
	scccl+="<eventlist>"+NL;

	sctcl+="shuffledebug="+bts(ShuffleDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="shoutcastdebug="+bts(SHOUTcastDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="uvoxdebug="+bts(UVOXDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="gaindebug="+bts(GainDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="playlistdebug="+bts(PlaylistDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="mp3encdebug="+bts(MP3EncDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="mp3decdebug="+bts(MP3DecDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="resamplerdebug="+bts(ResamplerDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="rgcalcdebug="+bts(RGCalcDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="apidebug="+bts(APIDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="calendardebug="+bts(CalendarDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="capturedebug="+bts(CaptureDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="djdebug="+bts(DJDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="flashpolicyserverdebug="+bts(FlashPolicyServerDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="fileconverterdebug="+bts(FileConverterDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="sourcerelaydebug="+bts(SourceRelayDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="sourceandendpointmanagerdebug="+bts(SourceAndEndpointManagerDebug && (TransDebugMode!=0) || (TransDebugMode==1))+NL;
	sctcl+="streamtitle="+StreamTitle+NL;
	sctcl+="streamurl="+StreamURL+NL;
	sctcl+="genre="+StreamGenre+NL;
	if(AIM!="")sctcl+="aim="+AIM+NL;
	if(IRC!="")sctcl+="irc="+IRC+NL;
	if(ICQ!="")sctcl+="icq="+ICQ+NL;
	sctcl+="usemetadata="+bts(UseMetadata)+NL;
	if(MetadataPattern!="")sctcl+="metadatapattern="+MetadataPattern+NL;
	if(DisplayMetadataPattern!="")sctcl+="displaymetadatapattern="+DisplayMetadataPattern+NL;
	if(TransAdminPort>0 && TransAdminPort<65536) {
		sctcl+="adminport="+TransAdminPort+NL;
		sctcl+="adminpassword="+AdminPassword+NL;
		sctcl+="adminuser=admin"+NL;
	}
	else {
		sctcl+="adminport=0"+NL;
	}
	if(VUImageDirectory!="") {
		sctcl+="vuimagedirectory="+MarryBasePathAndFile(TranscoderBasePath,VUImageDirectory)+NL;
	}
	sctcl+="vuimagesuffix="+VUImageSuffix+NL;
	if(VUImageMimeType!="") {
		sctcl+="vuimagemimetype="+VUImageMimeType+NL;
	}
	if(FlashPolicyFile!="") {
		sctcl+="flashpolicyfile="+MarryBasePathAndFile(TranscoderBasePath,FlashPolicyFile)+NL;
	}
	if(FlashPolicyServerPort>0 && FlashPolicyServerPort<65536 && FlashPolicyServerPort!=NaN && FlashPolicyServerPort!=null) {
		sctcl+="flashpolicyserverport="+FlashPolicyServerPort+NL;
	}
	else {
		sctcl+="flashpolicyserverport=0"+NL;
	}
	sctcl+="password="+Password+NL;
	if(MP3UnlockKeyName!="") {
		sctcl+="unlockkeyname="+MP3UnlockKeyName+NL;
	}
	if(MP3UnlockKeyCode!="") {
		sctcl+="unlockkeycode="+MP3UnlockKeyCode+NL;
	}
	sctcl+="log="+bts(EnableLogging)+NL;
	sctcl+="screenlog="+bts(Screenlog)+NL;
	sctcl+="logfile="+MarryBasePathAndFile(TranscoderBasePath,TransLogFile)+NL;
	sctcl+="public="+bts(SCTransPublic)+NL;
	if(Mode==1) {
		sctcl+="uvoxradiometadata=1"+NL;
		sctcl+="uvoxnewmetadata=0"+NL;
	}
	else {
		sctcl+="uvoxradiometadata=0"+NL;
		sctcl+="uvoxnewmetadata=1"+NL;
	}
	if(PlaylistFile!="")
	{
		sctcl+="playlistfile="+MarryBasePathAndFile(TranscoderBasePath,PlaylistFile)+NL;
	}
	sctcl+="shuffle="+bts(EnableShuffle)+NL;
	if(XFadeTime!=0 && XFadeTime!="" && XFadeTime!=NaN && XFadeTime!=null) {
		sctcl+="xfade="+XFadeTime+NL;
		if(XFadeThreshold!=0 && XFadeThreshold!="" && XFadeThreshold!=NaN && XFadeThreshold!=null) {
			sctcl+="xfadethreshold="+XFadeThreshold+NL;
		}
		else {
			sctcl+="xfadethreshold=0"+NL;
		}
	}
	else {
		sctcl+="xfade=0"+NL;
	}
	if(PlaylistFolder!="") {
		sctcl+="playlists="+MarryBasePathAndFile(TranscoderBasePath,PlaylistFolder)+NL;
	}
	if(PlaylistArchiveFolder!="") {
		sctcl+="archive="+MarryBasePathAndFile(TranscoderBasePath,PlaylistArchiveFolder)+NL;
	}
	if(CalendarFile!="") {
		sctcl+="calendarfile="+MarryBasePathAndFile(TranscoderBasePath,CalendarFile)+NL;
	}
	sctcl+="calendarrewrite="+bts(CalendarEnableRewrite)+NL;
	var djp1v=(DJPort>0 && DJPort<65536 && DJPort!=NaN);
	var djp2v=(DJPort2>0 && DJPort2<65536 && DJPort2!=NaN);
	var djpv=(djp1v || djp2v);
	if(djp1v && djp2v && djpv) {
		if(DJPort+1==DJPort2)djpv=false;
	}
	if(djpv) {
		if(djp1v) {
			sctcl+="djport="+DJPort+NL;
		}
		else {
			sctcl+="djport=0"+NL;
		}
		if(djp2v) {
			sctcl+="djport2="+DJPort2+NL;
		}
		else {
			sctcl+="djport2=0"+NL;
		}
		sctcl+="autodumpsourcetime="+DJAutoDumpSourceTime+NL;
		sctcl+="djcapture="+bts(DJCaptureEnable)+NL;
		if(DJCaptureEnable) {
			sctcl+="djbroadcasts="+MarryBasePathAndFile(TranscoderBasePath,DJBroadcastsPath)+NL;
			if(DJFilePattern!="")sctcl+="djfilepattern="+DJFilePattern+NL;
		}
	}
	else {
		sctcl+="djport=0"+NL;
		sctcl+="djport2=0"+NL;
	}
	if(DJCipher!="")sctcl+="djcipher="+DJCipher+NL;
	sctcl+="capture="+bts(EnableCapture)+NL;
	if(EnableCapture) {
		sctcl+="capturedevice="+CaptureDevice+NL;
		sctcl+="captureinput="+CaptureInput+NL;
		sctcl+="capturesamplerate="+CaptureSampleRate+NL;
		sctcl+="capturechannels="+CaptureNumChannels+NL;
	}
	sctcl+="applyreplaygain="+bts(ApplyReplayGain)+NL;
	if(DefaultReplayGain!="") {
		sctcl+="defaultreplaygain="+DefaultReplayGain+NL;
	}
	if(DJReplayGain!="") {
		sctcl+="djreplaygain="+DJReplayGain+NL;
	}
	if(CaptureReplayGain!="") {
		sctcl+="capturereplaygain="+CaptureReplayGain+NL;
	}
	sctcl+="calculatereplaygain="+bts(CalculateReplayGain)+NL;
	if(ReplayGainTempFolder!="") {
		sctcl+="replaygaintmpdir="+MarryBasePathAndFile(TranscoderBasePath,ReplayGainTempFolder)+NL;
	}
	sctcl+="replaygainrunahead="+ReplayGainRunAhead+NL;
	sctcl+="replaygaindontwrite="+bts(ReplayGainDontWrite)+NL;
	if(EnhanceReplayGain!="") {
		sctcl+="enhancereplaygain="+EnhanceReplayGain+NL;
	}
	sctcl+="timemultiplier="+TimeMultiplier+NL;
	if(ServerBackupFile!="") {
		sctcl+="serverbackupfile="+MarryBasePathAndFile(TranscoderBasePath,ServerBackupFile)+NL;
	}
	if(ServerIntroFile!="") {
		sctcl+="serverintrofile="+MarryBasePathAndFile(TranscoderBasePath,ServerIntroFile)+NL;
	}

	var sa=0;
	for(var i=0;i<NumOfPlaylists;i++) {
		var pn=PlaylistMultiSymNameArray[i];
		var pf=PlaylistMultiFileArray[i];
		if(pn=="" || pf==""){sa++;continue;}
		sctcl+=NL;
		sctcl+="playlistfilename_"+(i-sa)+"="+pn+NL;
		sctcl+="playlistfilepath_"+(i-sa)+"="+MarryBasePathAndFile(TranscoderBasePath,pf)+NL;
	}

	var sa=0;
	for(var i=0;i<NumOfDJs;i++) {
		var dl=DJLoginArray[i];
		var dp=DJPasswordArray[i];
		if(dl=="" || dp==""){sa++;continue;}

		sctcl+=NL;
		sctcl+="djlogin_"+(i-sa)+"="+dl+NL;
		sctcl+="djpassword_"+(i-sa)+"="+dp+NL;
		sctcl+="djpriority_"+(i-sa)+"="+(DJPriorityArray[i])*1+NL;
	}
	
	for(var i=0;i<NumOfCalendarEvents;i++) {
		var cet=CalendarEventTypeArray[i];
		var cdja=CalendarDJArchiveArray[i];
		var cdjn=CalendarDJNameArray[i];
		var cpl=CalendarPlaylistLoopAtEndArray[i];
		var cps=CalendarPlaylistShuffleArray[i];
		var cpp=CalendarPlaylistPriorityArray[i];
		var cpn=CalendarPlaylistNameArray[i];
		var cru=CalendarRelayURLArray[i];
		var crp=CalendarRelayPriorityArray[i];
		if(cet=="dj") {
			if(cdjn=="")continue;
			scccl+="\t<event type=\""+cet+"\">"+NL;
			scccl+="\t\t<dj archive=\""+cdja+"\">"+cdjn+"</dj>"+NL;
		}
		if(cet=="playlist") {
			if(cpn=="")continue;
			if(cpp=="")continue;
			scccl+="\t<event type=\""+cet+"\">"+NL;
			scccl+="\t\t<playlist loopatend=\""+bts(cpl)+"\" shuffle=\""+cps+"\" priority=\""+cpp+"\">"+NL;
			scccl+="\t\t\t"+cpn+NL;
			scccl+="\t\t</playlist>"+NL;
		}
		if(cet=="relay") {
			if(cru=="")continue;
			if(crp=="")continue;
			scccl+="\t<event type=\""+cet+"\">"+NL;
			scccl+="\t\t<relay url=\""+cru+"\" priority=\""+crp+"\"/>"+NL;
		}
		var rep=0;
		if(CalendarPerArray[i]){rep+=128;}
		if(CalendarSunArray[i]){rep+=1;}
		if(CalendarMonArray[i]){rep+=2;}
		if(CalendarTueArray[i]){rep+=4;}
		if(CalendarWedArray[i]){rep+=8;}
		if(CalendarThuArray[i]){rep+=16;}
		if(CalendarFriArray[i]){rep+=32;}
		if(CalendarSatArray[i]){rep+=64;}
		var sd=CalendarStartDateArray[i];
		var ed=CalendarEndDateArray[i];
		var st=CalendarStartTimeArray[i];
		var d=CalendarDurationArray[i];
		var to=CalendarTimeOffsetArray[i];
		var su=false;
		if(rep>0){su=true;rep=""+NL+"\t\t\trepeat=\""+rep+"\""+"\t\t";}else {rep="";}
		if(sd!=""){su=true;sd=""+NL+"\t\t\tstartdate=\""+sd+"\""+"\t\t";}else{sd="";}
		if(ed!=""){su=true;ed=""+NL+"\t\t\tenddate=\""+ed+"\""+"\t\t";}else{ed="";}
		if(st!=""){su=true;st=""+NL+"\t\t\tstarttime=\""+st+"\""+"\t\t";}else{st="";}
		if(d!=""){su=true;d=  ""+NL+"\t\t\tduration=\""+d+"\""+"\t\t";}else{d="";}
		if(to!=""){su=true;to=""+NL+"\t\t\ttimeoffset=\""+to+"\""+"\t\t";}else{to="";}
		if(su){su=NL+"\t\t";}else{su=" ";}
		scccl+="\t\t<calendar"+rep+sd+ed+st+d+to+su+"/>"+NL;
		scccl+="\t</event>"+NL;
	}

	scscl+="yp1debug="+bts(YP1Debug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="yp2debug="+bts(YP2Debug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="shoutcastsourcedebug="+bts(SHOUTcastSourceDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="uvox2sourcedebug="+bts(UVOX2SourceDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="shoutcast1clientdebug="+bts(SHOUTcast1ClientDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="shoutcast2clientdebug="+bts(SHOUTcast2ClientDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="relayshoutcastdebug="+bts(RelaySHOUTcastDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="relayuvoxdebug="+bts(RelayUVOXDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="relaydebug="+bts(RelayDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="streamdatadebug="+bts(StreamDataDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="httpstyledebug="+bts(HTTPStyleDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="statsdebug="+bts(StatsDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="microserverdebug="+bts(MicroServerDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="threadrunnerdebug="+bts(ThreadRunnerDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	scscl+="rtmpclientdebug="+bts(RTMPClientDebug && (DNASDebugMode!=0) || (DNASDebugMode==1))+NL;
	if(DJCipher!="")scscl+="uvoxcipherkey="+DJCipher+NL;
	if(DNASIntroFile!="") {
		scscl+="introfile="+MarryBasePathAndFile(DNASBasePath,DNASIntroFile)+NL;
	}
	if(DNASBackupFile!="") {
		scscl+="backupfile="+MarryBasePathAndFile(DNASBasePath,DNASBackupFile)+NL;
	}
	if(DNASSpecialFileTmpDir!="") {
		scscl+="specialfiletmpdir="+MarryBasePathAndFile(DNASBasePath,DNASSpecialFileTmpDir)+NL;
	}

	if(DNASAdminPageTheme!="v1" && DNASAdminPageTheme!="v2" && DNASAdminPageTheme!="") {
		scscl+="admincssfile="+MarryBasePathAndFile(DNASBasePath,DNASAdminPageTheme)+NL;
	}
	else {
		if(DNASAdminPageTheme=="") {
			scscl+="admincssfile=v2"+NL;
		}
		else {
			scscl+="admincssfile="+DNASAdminPageTheme+NL;
		}
	}

	scscl+="maxspecialfilesize="+MaxSpecialFileSize+NL;
	scscl+="songhistory="+SongHistory+NL;
	scscl+="namelookups="+bts(NameLookups)+NL;
	scscl+="maxheaderlinesize="+MaxHeaderLineSize+NL;
	scscl+="maxheaderlinecount="+MaxHeaderLineCount+NL;
	scscl+="buffertype="+BufferType+NL;
	switch(BufferType) {
		case 0:
			scscl+="fixedbuffersize="+FixedBufferSize+NL;
		break;
		case 1:
			scscl+="adaptivebuffersize="+AdaptiveBufferSize+NL;
		break;
	}
	scscl+="bufferhardlimit="+BufferHardLimit+NL;

	scscl+="password="+Password+NL;
	scscl+="adminpassword="+AdminPassword+NL;
	if(DNASFlashPolicyFile!="") {
		scscl+="flashpolicyfile="+MarryBasePathAndFile(DNASBasePath,DNASFlashPolicyFile)+NL;
	}
	scscl+="portbase="+PortBase+NL;
	if(SourceBindAddress!="") {
		scscl+="srcip="+SourceBindAddress+NL;
	}
	if(DestinationBindAddress!="") {
		scscl+="dstip="+DestinationBindAddress+NL;
	}
	if(Mode==1) {
		scscl+="requirestreamconfigs=0"+NL;
		scscl+="yp2=0"+NL;
	}
	else {
		scscl+="requirestreamconfigs=1"+NL;
		scscl+="yp2=1"+NL;
	}
	scscl+="log="+bts(EnableLogging)+NL;
	scscl+="screenlog="+bts(Screenlog)+NL;
	scscl+="logfile="+MarryBasePathAndFile(DNASBasePath,DNASLogFile)+NL;
	scscl+="w3cenable="+bts(W3CLogging)+NL;	
	scscl+="w3clog="+MarryBasePathAndFile(DNASBasePath,W3CLogFile)+NL;
	scscl+="webclientdebug="+bts(WebClientDebug)+NL;
	if(TitleFormat!="") {
		scscl+="titleformat="+TitleFormat+NL;
	}
	if(URLFormat!="") {
		scscl+="urlformat="+URLFormat+NL;
	}
	scscl+="publicserver="+DNASPublic+NL;
	scscl+="metainterval="+MetaInterval+NL;
	scscl+="ypaddr="+YPAddr+NL;
	scscl+="ypport="+YPPort+NL;
	scscl+="ypPath="+YPPath+NL;
	scscl+="ypTimeout="+YPTimeout+NL;
	scscl+="ypmaxretries="+YPMaxRetries+NL;
	scscl+="ypreportinterval="+YPReportInterval+NL;
	scscl+="ypminreportinterval="+YPMinReportInterval+NL;
	scscl+="banfile="+MarryBasePathAndFile(DNASBasePath,BanFile)+NL;
	scscl+="ripfile="+MarryBasePathAndFile(DNASBasePath,RipFile)+NL;
	scscl+="riponly="+bts(RipOnly)+NL;
	scscl+="savebanlistonexit=1"+NL;
	scscl+="saveriplistonexit=1"+NL;
	scscl+="maxuser="+MaxListeners+NL;
	scscl+="listenertime="+ListenerTime+NL;
	scscl+="autodumpusers="+bts(AutoDumpUsers)+NL;

	if(Mode==2) {
		var rindex;
		for(var i=0;i<NumOfEndPoints;i++) {
			scscl+=NL;
			sctcl+=NL;

			rindex=i+1;
			scscl+="streamid_"+rindex+"="+rindex+NL;
			scscl+="streampath_"+rindex+"="+EndPointPathInputArray[i].value+NL;
			var epmu=EndPointMaxUserInputArray[i].value;
			if(epmu!="") {
				scscl+="streammaxuser_"+rindex+"="+epmu+NL;
			}
			var epah=EndPointAuthHashInputArray[i].value;
			if(epah=="") {
				epah=DefaultAuthHash;
			}
			if(epah!="") {
				scscl+="streamauthhash_"+rindex+"="+epah+NL;
			}

			sctcl+="endpointname_"+i+"="+EndPointNameInputArray[i].value+NL;
			sctcl+="outprotocol_"+i+"=3"+NL;
			sctcl+="serverip_"+i+"="+DNASIP+NL;
			sctcl+="serverport_"+i+"="+PortBase+NL;
			sctcl+="uvoxstreamid_"+i+"="+rindex+NL;
			sctcl+="uvoxuserid_"+i+"=admin"+NL;
			sctcl+="uvoxauth_"+i+"="+Password+NL;
			sctcl+="uvoxradiometadata_"+i+"=0"+NL;
			sctcl+="uvoxnewmetadata_"+i+"=1"+NL;
			var ec=EndPointTypeSelectArray[i].value;
			sctcl+="encoder_"+i+"="+ec+NL;
			if(ec=="aacp") {
				sctcl+="aacformat_"+i+"="+EndPointAACFormatSelectArray[i].value+NL;
			}
			if(ec=="mp3") {
				sctcl+="mp3quality_"+i+"="+EndPointMP3QualitySelectArray[i].value+NL;
				sctcl+="mp3mode_"+i+"="+EndPointMP3ModeSelectArray[i].value+NL;
			}
			sctcl+="bitrate_"+i+"="+EndPointBitrateInputArray[i].value+NL;
			sctcl+="samplerate_"+i+"="+EndPointSamplerateInputArray[i].value+NL;
			sctcl+="channels_"+i+"="+EndPointNumchnsInputArray[i].value+NL;
		}
	}
	else {
		sctcl+=NL;
		sctcl+="serverport="+PortBase+NL;
		sctcl+="serverip="+DNASIP+NL;
		sctcl+="password="+Password+NL;
		sctcl+="outprotocol=1"+NL;
		var ec=EndPointTypeSelectArray[0].value;
		sctcl+="encoder="+ec+NL;
		if(ec=="aacp") {
			sctcl+="aacformat="+EndPointAACFormatSelectArray[0].value+NL;
		}
		if(ec=="mp3") {
			sctcl+="mp3quality="+EndPointMP3QualitySelectArray[0].value+NL;
			sctcl+="mp3mode="+EndPointMP3ModeSelectArray[0].value+NL;
		}
		sctcl+="bitrate="+EndPointBitrateInputArray[0].value+NL;
		sctcl+="samplerate="+EndPointSamplerateInputArray[0].value+NL;
		sctcl+="channels="+EndPointNumchnsInputArray[0].value+NL;
	}

	scccl+="</eventlist>"+NL;

	try{SCServLinesTextArea.innerHTML=scscl;}catch(e){}
	try{SCTransLinesTextArea.innerHTML=sctcl;}catch(e){}
	try{SCCalendarLinesTextArea.innerHTML=scccl;}catch(e){}
	try{SCServLinesTextArea.innerText=scscl;}catch(e){}
	try{SCTransLinesTextArea.innerText=sctcl;}catch(e){}
	try{SCCalendarLinesTextArea.innerText=scccl;}catch(e){}
	PopUpdateKill();
}

var LastHelpObj=0;
function DoHelpUpdate(Obj) {
	if(LastHelpObj==Obj) return;
	if(HelperTextDBKeysArray.lenght<1)return;
	if(HelperTextDBValuesArray.lenght<1)return;
	LastHelpObj=Obj;
	if(Obj==null) {
		uht(Obj,"Select an option or move your mouse over it to get additional information about that option.");
		return;
	}
	if(Obj.id=="") {
		return;
	}
	for(var i=0;i<HelperTextDBKeysArray.length;i++) {
		var uu=HelperTextDBKeysArray[i].split("\t");
		var id=Obj.id;
		if(id==uu[0]) {
			uht(Obj,HelperTextDBValuesArray[i]);
			return;
		}
		if(uu.length>1) {
			if(id.indexOf(uu[0])==0) {
				if(id.indexOf(uu[1])==(id.length-uu[1].length)) {
					uht(Obj,HelperTextDBValuesArray[i]);
					return;
				}
			}
		}
	}
	uht(Obj,"No information is available for the option selected at this time.");
}

function onObjFocused(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	DoHelpUpdate(obj);
}

function onObjMousedOver(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	DoHelpUpdate(obj);
}

function AETFC(eo,ee) {
	if(eo==null)return;
	if(eo.type=="checkbox" || eo.type=="button" || eo.type=="radio") {
		eo.onclick=ee;
	}
	else {
		eo.onchange=ee;
	}
	eo.onkeyup=ee;
	eo.onfocus=onObjFocused;
	eo.onmouseover=onObjMousedOver;
}

function DoDeleteDJ(obj) {
	var dji=DJDeleteButtonArray.indexOf(obj);
	NumOfDJs--;
	var t=NumOfDJsHidden.onchange;
	NumOfDJsHidden.onchange=null;
	NumOfDJsHidden.value=NumOfDJs;
	SetObjCookie(NumOfDJsHidden);
	NumOfDJsHidden.onchange=t;
	for(var i=dji;i<NumOfDJs;i++) {
		DJLoginInputArray[i].value=DJLoginInputArray[i+1].value;
		DJLoginArray[i]=DJLoginArray[i+1];
		SetObjCookie(DJLoginInputArray[i]);

		DJPasswordInputArray[i].value=DJPasswordInputArray[i+1].value;
		DJPasswordArray[i]=DJPasswordArray[i+1];
		SetObjCookie(DJPasswordInputArray[i]);

		DJPriorityInputArray[i].value=DJPriorityInputArray[i+1].value;
		DJPriorityArray[i].value=DJPriorityArray[i+1].value;
		SetObjCookie(DJPriorityInputArray[i]);
	}
	var vi=DJLoginInputArray.pop();
	EraseObjCookie(vi);
	var vi=DJPasswordInputArray.pop();
	EraseObjCookie(vi);
	var vi=DJPriorityInputArray.pop();
	EraseObjCookie(vi);
	var vi=DJDeleteButtonArray.pop();
	EraseObjCookie(vi);
	createCookie("NumOfDJsHidden",NumOfDJs);
	MultiDJSpanUpdate();
}

function DoAddDJ() {
	NumOfDJs++;
	var t=NumOfDJsHidden.onchange;
	NumOfDJsHidden.onchange=null;
	NumOfDJsHidden.value=NumOfCalendarEvents;
	SetObjCookie(NumOfDJsHidden);
	NumOfDJsHidden.onchange=t;
	MultiDJSpanUpdate();
}

function MultiDJSpanUpdate() {
	delete DJLoginInputArray;
	delete DJPasswordInputArray;
	delete DJPriorityInputArray;
	delete DJCalendarAddButtonArray;
	delete DJDeleteButtonArray;
	delete DJLoginArray;
	delete DJPasswordArray;
	delete DJPriorityArray;
	var fark="";
	MultiDJSpan.innerHTML=fark;
	DJLoginInputArray=new Array(NumOfDJs);
	DJPasswordInputArray=new Array(NumOfDJs);
	DJPriorityInputArray=new Array(NumOfDJs);
	DJCalendarAddButtonArray=new Array(NumOfDJs);
	DJDeleteButtonArray=new Array(NumOfDJs);
	DJLoginArray=new Array(NumOfDJs);
	DJPasswordArray=new Array(NumOfDJs);
	DJPriorityArray=new Array(NumOfDJs);
	var c=NumOfDJs;
	for(var rindex=0;rindex<NumOfDJs;rindex++) {
		var naid="DJ"+rindex+"DeleteButton";
		fark+="<br/><br/><input name=\""+naid+"\" id=\""+naid+"\" type=\"button\" class=\"button\" value=\"Remove DJ\"/><br/>";

		fark+="<table border=\"0\">";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class=\"ConfigTableDescTD\">";
		var naid="DJ"+rindex+"LoginInput";
		fark+="DJ&nbsp;Login&nbsp;Name</td><td><input name=\""+naid+"\" id=\""+naid+"\"/>";
		fark+="</td></tr>";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class=\"ConfigTableDescTD\">";
		var naid="DJ"+rindex+"CalendarAddButton";
		fark+="<input name=\""+naid+"\" id=\""+naid+"\" type=\"button\" class=\"button\" value=\"Calendar\"/></td><td>Add DJ to the calendar";
		fark+="</td></tr>";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class=\"ConfigTableDescTD\">";
		var naid="DJ"+rindex+"PasswordInput";
		fark+="DJ&nbsp;Password</td><td><input name=\""+naid+"\" id=\""+naid+"\"/>";
		fark+="</td></tr>";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td class=\"ConfigTableDescTD\">";
		var naid="DJ"+rindex+"PriorityInput";
		fark+="DJ&nbsp;Priority</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"1\"/>";
		fark+="</td></tr>";

		fark+="</table>";
	}
	MultiDJSpan.innerHTML=fark;
	for(var rindex=0;rindex<NumOfDJs;rindex++) {
		var naid="DJ"+rindex+"LoginInput";
		var vi=document.getElementById(naid);
		DJLoginInputArray[rindex]=vi;
		DJLoginArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onDJLoginInputChanged);

		var naid="DJ"+rindex+"PasswordInput";
		vi=document.getElementById(naid);
		DJPasswordInputArray[rindex]=vi;
		DJPasswordArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onDJPasswordInputChanged);

		var naid="DJ"+rindex+"PriorityInput";
		vi=document.getElementById(naid);
		DJPriorityInputArray[rindex]=vi;
		DJPriorityArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onDJPriorityInputChanged);

		var naid="DJ"+rindex+"CalendarAddButton";
		vi=document.getElementById(naid);
		DJCalendarAddButtonArray[rindex]=vi;
		AETFC(vi,onDJCalendarAddButtonClicked);

		var naid="DJ"+rindex+"DeleteButton";
		vi=document.getElementById(naid);
		DJDeleteButtonArray[rindex]=vi;
		AETFC(vi,onDJDeleteButtonClicked);
	}
}

function DoCalendarEventTypeSelectUpdate(obj) {
	var i=CalendarEventTypeSelectArray.indexOf(obj);
	var y=document.getElementById("Calendar"+i+"DJEventSpan");
	if(obj.value!="dj") {
		y.style.visibility="hidden";
		y.style.display="none";
	}
	else {
		y.style.visibility="visible";
		y.style.display="block";
	}
	var y=document.getElementById("Calendar"+i+"PlaylistEventSpan");
	if(obj.value!="playlist") {
		y.style.visibility="hidden";
		y.style.display="none";
	}
	else {
		y.style.visibility="visible";
		y.style.display="block";
	}
	var y=document.getElementById("Calendar"+i+"RelayEventSpan");
	if(obj.value!="relay") {
		y.style.visibility="hidden";
		y.style.display="none";
	}
	else {
		y.style.visibility="visible";
		y.style.display="block";
	}
}

function onNumOfCalendarEventsHiddenChanged() {
	NumOfCalendarEvents=(NumOfCalendarEventsHidden.value)*1;
	SetObjCookie(NumOfCalendarEventsHidden);
	MultiCalendarSpanUpdate();
	DoUpdate();
}

function onCalendarEventTypeSelectChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarEventTypeSelectArray.indexOf(obj)
	if(i<0)return;
	CalendarEventTypeArray[i]=(CalendarEventTypeSelectArray[i].value);
	SetObjCookie(CalendarEventTypeSelectArray[i]);
	DoCalendarEventTypeSelectUpdate(obj);
	DoUpdate();
}

function onCalendarDJNameInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarDJNameInputArray.indexOf(obj)
	if(i<0)return;
	CalendarDJNameArray[i]=(CalendarDJNameInputArray[i].value);
	SetObjCookie(CalendarDJNameInputArray[i]);
	DoUpdate();
}

function onCalendarDJArchiveSelectChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarDJArchiveSelectArray.indexOf(obj)
	if(i<0)return;
	CalendarDJArchiveArray[i]=(CalendarDJArchiveSelectArray[i].value);
	SetObjCookie(CalendarDJArchiveSelectArray[i]);
	DoUpdate();
}

function onCalendarPlaylistNameInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarPlaylistNameInputArray.indexOf(obj)
	if(i<0)return;
	CalendarPlaylistNameArray[i]=(CalendarPlaylistNameInputArray[i].value);
	SetObjCookie(CalendarPlaylistNameInputArray[i]);
	DoUpdate();
}

function onCalendarPlaylistLoopAtEndCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarPlaylistLoopAtEndCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarPlaylistLoopAtEndArray[i]=(CalendarPlaylistLoopAtEndCheckBoxArray[i].checked);
	SetObjCookie(CalendarPlaylistLoopAtEndCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarPlaylistShuffleSelectChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarPlaylistShuffleSelectArray.indexOf(obj)
	if(i<0)return;
	CalendarPlaylistShuffleArray[i]=(CalendarPlaylistShuffleSelectArray[i].value);
	SetObjCookie(CalendarPlaylistShuffleSelectArray[i]);
	DoUpdate();
}

function onCalendarPlaylistPriorityInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarPlaylistPriorityInputArray.indexOf(obj)
	if(i<0)return;
	CalendarPlaylistPriorityArray[i]=(CalendarPlaylistPriorityInputArray[i].value);
	SetObjCookie(CalendarPlaylistPriorityInputArray[i]);
	DoUpdate();
}

function onCalendarRelayURLInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarRelayURLInputArray.indexOf(obj)
	if(i<0)return;
	CalendarRelayURLArray[i]=(CalendarRelayURLInputArray[i].value);
	SetObjCookie(CalendarRelayURLInputArray[i]);
	DoUpdate();
}

function onCalendarRelayPriorityInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarRelayPriorityInputArray.indexOf(obj)
	if(i<0)return;
	CalendarRelayPriorityArray[i]=(CalendarRelayPriorityInputArray[i].value);
	SetObjCookie(CalendarRelayPriorityInputArray[i]);
	DoUpdate();
}

function onCalendarPerCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarPerCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarPerArray[i]=(CalendarPerCheckBoxArray[i].checked);
	SetObjCookie(CalendarPerCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarSunCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarSunCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarSunArray[i]=(CalendarSunCheckBoxArray[i].checked);
	SetObjCookie(CalendarSunCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarMonCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarMonCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarMonArray[i]=(CalendarMonCheckBoxArray[i].checked);
	SetObjCookie(CalendarMonCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarTueCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarTueCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarTueArray[i]=(CalendarTueCheckBoxArray[i].checked);
	SetObjCookie(CalendarTueCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarWedCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarWedCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarWedArray[i]=(CalendarWedCheckBoxArray[i].checked);
	SetObjCookie(CalendarWedCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarThuCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarThuCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarThuArray[i]=(CalendarThuCheckBoxArray[i].checked);
	SetObjCookie(CalendarThuCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarFriCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarFriCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarFriArray[i]=(CalendarFriCheckBoxArray[i].checked);
	SetObjCookie(CalendarFriCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarSatCheckBoxClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarSatCheckBoxArray.indexOf(obj)
	if(i<0)return;
	CalendarSatArray[i]=(CalendarSatCheckBoxArray[i].checked);
	SetObjCookie(CalendarSatCheckBoxArray[i]);
	DoUpdate();
}

function onCalendarStartDateInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarStartDateInputArray.indexOf(obj)
	if(i<0)return;
	CalendarStartDateArray[i]=(CalendarStartDateInputArray[i].value);
	SetObjCookie(CalendarStartDateInputArray[i]);
	DoUpdate();
}

function onCalendarEndDateInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarEndDateInputArray.indexOf(obj)
	if(i<0)return;
	CalendarEndDateArray[i]=(CalendarEndDateInputArray[i].value);
	SetObjCookie(CalendarEndDateInputArray[i]);
	DoUpdate();
}

function onCalendarStartTimeInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarStartTimeInputArray.indexOf(obj)
	if(i<0)return;
	CalendarStartTimeArray[i]=(CalendarStartTimeInputArray[i].value);
	SetObjCookie(CalendarStartTimeInputArray[i]);
	DoUpdate();
}

function onCalendarDurationInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarDurationInputArray.indexOf(obj)
	if(i<0)return;
	CalendarDurationArray[i]=(CalendarDurationInputArray[i].value);
	SetObjCookie(CalendarDurationInputArray[i]);
	DoUpdate();
}

function onCalendarTimeOffsetInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=CalendarTimeOffsetInputArray.indexOf(obj)
	if(i<0)return;
	CalendarTimeOffsetArray[i]=(CalendarTimeOffsetInputArray[i].value);
	SetObjCookie(CalendarTimeOffsetInputArray[i]);
	DoUpdate();
}

function DoAddCalendarEvent() {
	NumOfCalendarEvents++;
	var t=NumOfCalendarEventsHidden.onchange;
	NumOfCalendarEventsHidden.onchange=null;
	NumOfCalendarEventsHidden.value=NumOfCalendarEvents;
	SetObjCookie(NumOfCalendarEventsHidden);
	NumOfCalendarEventsHidden.onchange=t;
	MultiCalendarSpanUpdate();
}

function onCalendarEventAddButtonClicked() {
	// check so that we only add in more events if the last attempt was ok
	if(!NumOfCalendarEvents ||
		CalendarEventTypeSelectArray[NumOfCalendarEvents-1].value=="dj" && CalendarDJNameInputArray[NumOfCalendarEvents-1].value ||
		CalendarEventTypeSelectArray[NumOfCalendarEvents-1].value=="playlist" && CalendarPlaylistNameInputArray[NumOfCalendarEvents-1].value ||
		CalendarEventTypeSelectArray[NumOfCalendarEvents-1].value=="relay" && CalendarRelayURLInputArray[NumOfCalendarEvents-1].value) {
		DoAddCalendarEvent();
		DoUpdate();
	}
}

function DoDeleteEvent(obj) {
	var dji=CalendarEventDeleteButtonArray.indexOf(obj);
	NumOfCalendarEvents--;
	var t=NumOfCalendarEventsHidden.onchange;
	NumOfCalendarEventsHidden.onchange=null;
	NumOfCalendarEventsHidden.value=NumOfCalendarEvents;
	SetObjCookie(NumOfCalendarEventsHidden);
	NumOfCalendarEventsHidden.onchange=t;
	for(var i=dji;i<NumOfCalendarEvents;i++) {

		CalendarEventTypeSelectArray[i].selectedIndex=CalendarEventTypeSelectArray[i+1].selectedIndex;
		CalendarEventTypeArray[i]=CalendarEventTypeArray[i+1];
		SetObjCookie(CalendarEventTypeSelectArray[i]);
		DoCalendarEventTypeSelectUpdate(CalendarEventTypeSelectArray[i]);

		CalendarDJNameInputArray[i].value=CalendarDJNameInputArray[i+1].value;
		CalendarDJNameArray[i]=CalendarDJNameArray[i+1];
		SetObjCookie(CalendarDJNameInputArray[i]);

		CalendarDJArchiveSelectArray[i].selectedIndex=CalendarDJArchiveSelectArray[i+1].selectedIndex;
		CalendarDJArchiveArray[i]=CalendarDJArchiveArray[i+1];
		SetObjCookie(CalendarDJArchiveSelectArray[i]);

		CalendarPlaylistNameInputArray[i].value=CalendarPlaylistNameInputArray[i+1].value;
		CalendarPlaylistNameArray[i]=CalendarPlaylistNameArray[i+1];
		SetObjCookie(CalendarPlaylistNameInputArray[i]);

		CalendarPlaylistLoopAtEndCheckBoxArray[i].checked=CalendarPlaylistLoopAtEndCheckBoxArray[i+1].checked;
		CalendarPlaylistLoopAtEndArray[i]=CalendarPlaylistLoopAtEndArray[i+1];
		SetObjCookie(CalendarPlaylistLoopAtEndCheckBoxArray[i]);

		CalendarPlaylistShuffleSelectArray[i].selectedIndex=CalendarPlaylistShuffleSelectArray[i+1].selectedIndex;
		CalendarPlaylistShuffleArray[i]=CalendarPlaylistShuffleArray[i+1];
		SetObjCookie(CalendarPlaylistShuffleSelectArray[i]);

		CalendarPlaylistPriorityInputArray[i].value=CalendarPlaylistPriorityInputArray[i+1].value;
		CalendarPlaylistPriorityArray[i]=CalendarPlaylistPriorityArray[i+1];
		SetObjCookie(CalendarPlaylistPriorityInputArray[i]);

		CalendarRelayURLInputArray[i].value=CalendarRelayURLInputArray[i+1].value;
		CalendarRelayURLArray[i]=CalendarRelayURLArray[i+1];
		SetObjCookie(CalendarRelayURLInputArray[i]);

		CalendarRelayPriorityInputArray[i].value=CalendarRelayPriorityInputArray[i+1].value;
		CalendarRelayPriorityArray[i]=CalendarRelayPriorityArray[i+1];
		SetObjCookie(CalendarRelayPriorityInputArray[i]);

		CalendarStartDateInputArray[i].value=CalendarStartDateInputArray[i+1].value;
		CalendarStartDateArray[i]=CalendarStartDateArray[i+1];
		SetObjCookie(CalendarStartDateInputArray[i]);

		CalendarEndDateInputArray[i].value=CalendarEndDateInputArray[i+1].value;
		CalendarEndDateArray[i]=CalendarEndDateArray[i+1];
		SetObjCookie(CalendarEndDateInputArray[i]);

		CalendarStartTimeInputArray[i].value=CalendarStartTimeInputArray[i+1].value;
		CalendarStartTimeArray[i].value=CalendarStartTimeArray[i+1];
		SetObjCookie(CalendarStartTimeInputArray[i]);

		CalendarDurationInputArray[i].value=CalendarDurationInputArray[i+1].value;
		CalendarDurationArray[i]=CalendarDurationArray[i+1];
		SetObjCookie(CalendarDurationInputArray[i]);

		CalendarTimeOffsetInputArray[i].value=CalendarTimeOffsetInputArray[i+1].value;
		CalendarTimeOffsetArray[i].value=CalendarTimeOffsetArray[i+1];
		SetObjCookie(CalendarTimeOffsetInputArray[i]);

		CalendarPerCheckBoxArray[i].checked=CalendarPerCheckBoxArray[i+1].checked;
		CalendarPerArray[i]=CalendarPerArray[i+1];
		SetObjCookie(CalendarPerCheckBoxArray[i]);

		CalendarSunCheckBoxArray[i].checked=CalendarSunCheckBoxArray[i+1].checked;
		CalendarSunArray[i]=CalendarSunArray[i+1];
		SetObjCookie(CalendarSunCheckBoxArray[i]);

		CalendarMonCheckBoxArray[i].checked=CalendarMonCheckBoxArray[i+1].checked;
		CalendarMonArray[i]=CalendarMonArray[i+1];
		SetObjCookie(CalendarMonCheckBoxArray[i]);

		CalendarTueCheckBoxArray[i].checked=CalendarTueCheckBoxArray[i+1].checked;
		CalendarTueArray[i]=CalendarTueArray[i+1];
		SetObjCookie(CalendarTueCheckBoxArray[i]);

		CalendarWedCheckBoxArray[i].checked=CalendarWedCheckBoxArray[i+1].checked;
		CalendarWedArray[i]=CalendarWedArray[i+1];
		SetObjCookie(CalendarWedCheckBoxArray[i]);

		CalendarThuCheckBoxArray[i].checked=CalendarThuCheckBoxArray[i+1].checked;
		CalendarThuArray[i]=CalendarThuArray[i+1];
		SetObjCookie(CalendarThuCheckBoxArray[i]);

		CalendarFriCheckBoxArray[i].checked=CalendarFriCheckBoxArray[i+1].checked;
		CalendarFriArray[i]=CalendarFriArray[i+1];
		SetObjCookie(CalendarFriCheckBoxArray[i]);

		CalendarSatCheckBoxArray[i].checked=CalendarSatCheckBoxArray[i+1].checked;
		CalendarSatArray[i]=CalendarSatArray[i+1];
		SetObjCookie(CalendarSatCheckBoxArray[i]);
	}
	var vi=CalendarEventTypeSelectArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarDJNameInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarDJArchiveSelectArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarPlaylistNameInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarPlaylistLoopAtEndCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarPlaylistShuffleSelectArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarPlaylistPriorityInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarRelayURLInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarRelayPriorityInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarStartDateInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarEndDateInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarStartTimeInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarDurationInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarTimeOffsetInputArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarPerCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarSunCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarMonCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarTueCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarWedCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarThuCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarFriCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarSatCheckBoxArray.pop();
	EraseObjCookie(vi);

	var vi=CalendarEventDeleteButtonArray.pop();

	MultiCalendarSpanUpdate();
}

function onCalendarEventDeleteButtonClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	DoDeleteEvent(obj);
	DoUpdate();
}

function MultiCalendarSpanUpdate() {
	delete CalendarEventDeleteButtonArray;
	delete CalendarEventTypeSelectArray;
	delete CalendarDJNameInputArray;
	delete CalendarDJArchiveSelectArray;
	delete CalendarPlaylistNameInputArray;
	delete CalendarPlaylistLoopAtEndCheckBoxArray;
	delete CalendarPlaylistShuffleSelectArray;
	delete CalendarPlaylistPriorityInputArray;
	delete CalendarRelayURLInputArray;
	delete CalendarRelayPriorityInputArray;
	delete CalendarPerCheckBoxArray;
	delete CalendarSunCheckBoxArray;
	delete CalendarMonCheckBoxArray;
	delete CalendarTueCheckBoxArray;
	delete CalendarWedCheckBoxArray;
	delete CalendarThuCheckBoxArray;
	delete CalendarFriCheckBoxArray;
	delete CalendarSatCheckBoxArray;
	delete CalendarStartDateInputArray;
	delete CalendarEndDateInputArray;
	delete CalendarStartTimeInputArray;
	delete CalendarDurationInputArray;
	delete CalendarTimeOffsetInputArray;
	delete CalendarEventTypeArray;
	delete CalendarDJNameArray;
	delete CalendarDJArchiveArray;
	delete CalendarPlaylistNameArray;
	delete CalendarPlaylistLoopAtEndArray;
	delete CalendarPlaylistShuffleArray;
	delete CalendarPlaylistPriorityArray;
	delete CalendarRelayURLArray;
	delete CalendarRelayPriorityArray;
	delete CalendarPerArray;
	delete CalendarSunArray;
	delete CalendarMonArray;
	delete CalendarTueArray;
	delete CalendarWedArray;
	delete CalendarThuArray;
	delete CalendarFriArray;
	delete CalendarSatArray;
	delete CalendarStartDateArray;
	delete CalendarEndDateArray;
	delete CalendarStartTimeArray;
	delete CalendarDurationArray;
	delete CalendarTimeOffsetArray;
	var fark="";
	MultiCalendarSpan.innerHTML=fark;
	CalendarEventDeleteButtonArray = new Array(NumOfCalendarEvents);
	CalendarEventTypeSelectArray = new Array(NumOfCalendarEvents);
	CalendarDJNameInputArray = new Array(NumOfCalendarEvents);
	CalendarDJArchiveSelectArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistNameInputArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistLoopAtEndCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistShuffleSelectArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistPriorityInputArray = new Array(NumOfCalendarEvents);
	CalendarRelayURLInputArray = new Array(NumOfCalendarEvents);
	CalendarRelayPriorityInputArray = new Array(NumOfCalendarEvents);
	CalendarPerCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarSunCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarMonCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarTueCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarWedCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarThuCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarFriCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarSatCheckBoxArray = new Array(NumOfCalendarEvents);
	CalendarStartDateInputArray = new Array(NumOfCalendarEvents);
	CalendarEndDateInputArray = new Array(NumOfCalendarEvents);
	CalendarStartTimeInputArray = new Array(NumOfCalendarEvents);
	CalendarDurationInputArray = new Array(NumOfCalendarEvents);
	CalendarTimeOffsetInputArray = new Array(NumOfCalendarEvents);
	CalendarEventTypeArray = new Array(NumOfCalendarEvents);
	CalendarDJNameArray = new Array(NumOfCalendarEvents);
	CalendarDJArchiveArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistNameArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistLoopAtEndArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistShuffleArray = new Array(NumOfCalendarEvents);
	CalendarPlaylistPriorityArray = new Array(NumOfCalendarEvents);
	CalendarRelayURLArray = new Array(NumOfCalendarEvents);
	CalendarRelayPriorityArray = new Array(NumOfCalendarEvents);
	CalendarPerArray = new Array(NumOfCalendarEvents);
	CalendarSunArray = new Array(NumOfCalendarEvents);
	CalendarMonArray = new Array(NumOfCalendarEvents);
	CalendarTueArray = new Array(NumOfCalendarEvents);
	CalendarWedArray = new Array(NumOfCalendarEvents);
	CalendarThuArray = new Array(NumOfCalendarEvents);
	CalendarFriArray = new Array(NumOfCalendarEvents);
	CalendarSatArray = new Array(NumOfCalendarEvents);
	CalendarStartDateArray = new Array(NumOfCalendarEvents);
	CalendarEndDateArray = new Array(NumOfCalendarEvents);
	CalendarStartTimeArray = new Array(NumOfCalendarEvents);
	CalendarDurationArray = new Array(NumOfCalendarEvents);
	CalendarTimeOffsetArray = new Array(NumOfCalendarEvents);
	for(var rindex=0;rindex<NumOfCalendarEvents;rindex++) {
		fark+="<br/><br/>";

		fark+="<table><tbody><tr><td>";
		var naid="Calendar"+(rindex)+"EventDeleteButton";
		fark+="<input name=\""+naid+"\" id=\""+naid+"\" type=\"button\" class=\"button\" value=\"Remove Event\"/>";
		fark+="</td></tr>";

		fark+="<tr><td>";
		fark+="<table><tr><td style=\"width:63px;\"class=\"ConfigTableDescTD\">";
		var naid="Calendar"+(rindex)+"EventTypeSelect";
		fark+="Type</td><td><select name=\""+naid+"\" id=\""+naid+"\"><option value=\"dj\">DJ</option><option value=\"playlist\">Playlist</option><option value=\"relay\">Relay</option></select>";
		fark+="</td></tr></table></td></tr>";

		fark+="<tr><td>";

		var naid="Calendar"+(rindex)+"DJEventSpan";
		fark+="<span id=\""+naid+"\">";
		fark+="<table>";
		var naid="Calendar"+(rindex)+"DJNameInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">DJ&nbsp;Name</td><td><input name=\""+naid+"\" id=\""+naid+"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"DJArchiveSelect";
		fark+="<tr><td class=\"ConfigTableDescTD\">Enable&nbsp;Archive</td><td><select name=\""+naid+"\" id=\""+naid+"\"><option value=\"inherit\">Inherit</option><option value=\"1\">Yes</option><option value=\"0\">No</option></select></td></tr>";
		fark+="</table>";
		fark+="</span>";

		var naid="Calendar"+(rindex)+"PlaylistEventSpan";
		fark+="<span id=\""+naid+"\">";
		fark+="<table>";
		var naid="Calendar"+(rindex)+"PlaylistNameInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Playlist&nbsp;Name</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"PlaylistLoopAtEndCheckBox";
		fark+="<tr><td class=\"ConfigTableDescTD\">Loop&nbsp;at&nbsp;playlist&nbsp;end</td><td><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\" checked=\"checked\"/></td></tr>";
		var naid="Calendar"+(rindex)+"PlaylistShuffleSelect";
		fark+="<tr><td class=\"ConfigTableDescTD\">Shuffle</td><td><select name=\""+naid+"\" id=\""+naid+"\"><option value=\"inherit\">Inherit</option><option value=\"1\">Yes</option><option value=\"0\">No</option></select></td></tr>";
		var naid="Calendar"+(rindex)+"PlaylistPriorityInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Priority</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"1\"/></td></tr>";
		fark+="</table>";
		fark+="</span>";

		var naid="Calendar"+(rindex)+"RelayEventSpan";
		fark+="<span id=\""+naid+"\">";
		fark+="<table>";
		var naid="Calendar"+(rindex)+"RelayURLInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">URL</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"RelayPriorityInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Priority</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"1\"/></td></tr>";
		fark+="</table>";
		fark+="</span>";

		fark+="</td></tr>";

		fark+="<tr><td>";

		fark+="<table>";
		var naid="Calendar"+(rindex)+"StartDateInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Start&nbsp;Date</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"EndDateInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">End&nbsp;Date</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"StartTimeInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Start&nbsp;Time</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"DurationInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Duration</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";
		var naid="Calendar"+(rindex)+"TimeOffsetInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Time&nbsp;Offset</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"\"/></td></tr>";

		fark+="<tr><td class=\"ConfigTableDescTD\">Repeat</td><td>";
		fark+="<table><tr><td>Sun</td><td>Mon</td><td>Tue</td><td>Wed</td><td>Thur</td><td>Fri</td><td>Sat</td><td>Periodic</td></tr><tr>";
		var naid="Calendar"+(rindex)+"SunCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"MonCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"TueCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"WedCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"ThuCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"FriCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"SatCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		var naid="Calendar"+(rindex)+"PerCheckBox";
		fark+="<td style=\"text-align:center\"><input name=\""+naid+"\" id=\""+naid+"\" type=\"checkbox\"/></td>";
		fark+="</tr></table>";

		fark+="</td></tr>";
		fark+="</table>";

		fark+="</td></tr></table>";
	}

	MultiCalendarSpan.innerHTML=fark;
	var vi;
	for(var rindex=0;rindex<NumOfCalendarEvents;rindex++) {
		var naid="Calendar"+(rindex)+"EventDeleteButton";
		vi=document.getElementById(naid);
		CalendarEventDeleteButtonArray[rindex]=vi;
		AETFC(vi,onCalendarEventDeleteButtonClicked);

		var naid="Calendar"+(rindex)+"EventTypeSelect";
		vi=document.getElementById(naid);
		CalendarEventTypeSelectArray[rindex]=vi;
		CalendarEventTypeArray[rindex]=GetObjCookie(vi);
		DoCalendarEventTypeSelectUpdate(vi);
		AETFC(vi,onCalendarEventTypeSelectChanged);

		var naid="Calendar"+(rindex)+"DJNameInput";
		vi=document.getElementById(naid);
		CalendarDJNameInputArray[rindex]=vi;
		CalendarDJNameArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarDJNameInputChanged);

		var naid="Calendar"+(rindex)+"DJArchiveSelect";
		vi=document.getElementById(naid);
		CalendarDJArchiveSelectArray[rindex]=vi;
		CalendarDJArchiveArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarDJArchiveSelectChanged);

		var naid="Calendar"+(rindex)+"PlaylistNameInput";
		vi=document.getElementById(naid);
		CalendarPlaylistNameInputArray[rindex]=vi;
		CalendarPlaylistNameArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarPlaylistNameInputChanged);

		var naid="Calendar"+(rindex)+"PlaylistLoopAtEndCheckBox";
		vi=document.getElementById(naid);
		CalendarPlaylistLoopAtEndCheckBoxArray[rindex]=vi;
		CalendarPlaylistLoopAtEndArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarPlaylistLoopAtEndCheckBoxClicked);

		var naid="Calendar"+(rindex)+"PlaylistShuffleSelect";
		vi=document.getElementById(naid);
		CalendarPlaylistShuffleSelectArray[rindex]=vi;
		CalendarPlaylistShuffleArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarPlaylistShuffleSelectChanged);

		var naid="Calendar"+(rindex)+"PlaylistPriorityInput";
		vi=document.getElementById(naid);
		CalendarPlaylistPriorityInputArray[rindex]=vi;
		CalendarPlaylistPriorityArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarPlaylistPriorityInputChanged);

		var naid="Calendar"+(rindex)+"RelayURLInput";
		vi=document.getElementById(naid);
		CalendarRelayURLInputArray[rindex]=vi;
		CalendarRelayURLArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarRelayURLInputChanged);

		var naid="Calendar"+(rindex)+"RelayPriorityInput";
		vi=document.getElementById(naid);
		CalendarRelayPriorityInputArray[rindex]=vi;
		CalendarRelayPriorityArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarRelayPriorityInputChanged);

		var naid="Calendar"+(rindex)+"PerCheckBox";
		vi=document.getElementById(naid);
		CalendarPerCheckBoxArray[rindex]=vi;
		CalendarPerArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarPerCheckBoxClicked);

		var naid="Calendar"+(rindex)+"SunCheckBox";
		vi=document.getElementById(naid);
		CalendarSunCheckBoxArray[rindex]=vi;
		CalendarSunArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarSunCheckBoxClicked);

		var naid="Calendar"+(rindex)+"MonCheckBox";
		vi=document.getElementById(naid);
		CalendarMonCheckBoxArray[rindex]=vi;
		CalendarMonArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarMonCheckBoxClicked);

		var naid="Calendar"+(rindex)+"TueCheckBox";
		vi=document.getElementById(naid);
		CalendarTueCheckBoxArray[rindex]=vi;
		CalendarTueArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarTueCheckBoxClicked);

		var naid="Calendar"+(rindex)+"WedCheckBox";
		vi=document.getElementById(naid);
		CalendarWedCheckBoxArray[rindex]=vi;
		CalendarWedArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarWedCheckBoxClicked);

		var naid="Calendar"+(rindex)+"ThuCheckBox";
		vi=document.getElementById(naid);
		CalendarThuCheckBoxArray[rindex]=vi;
		CalendarThuArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarThuCheckBoxClicked);

		var naid="Calendar"+(rindex)+"FriCheckBox";
		vi=document.getElementById(naid);
		CalendarFriCheckBoxArray[rindex]=vi;
		CalendarFriArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarFriCheckBoxClicked);

		var naid="Calendar"+(rindex)+"SatCheckBox";
		vi=document.getElementById(naid);
		CalendarSatCheckBoxArray[rindex]=vi;
		CalendarSatArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarSatCheckBoxClicked);

		var naid="Calendar"+(rindex)+"StartDateInput";
		vi=document.getElementById(naid);
		CalendarStartDateInputArray[rindex]=vi;
		CalendarStartDateArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarStartDateInputChanged);

		var naid="Calendar"+(rindex)+"EndDateInput";
		vi=document.getElementById(naid);
		CalendarEndDateInputArray[rindex]=vi;
		CalendarEndDateArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarEndDateInputChanged);

		var naid="Calendar"+(rindex)+"StartTimeInput";
		vi=document.getElementById(naid);
		CalendarStartTimeInputArray[rindex]=vi;
		CalendarStartTimeArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarStartTimeInputChanged);

		var naid="Calendar"+(rindex)+"DurationInput";
		vi=document.getElementById(naid);
		CalendarDurationInputArray[rindex]=vi;
		CalendarDurationArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarDurationInputChanged);

		var naid="Calendar"+(rindex)+"TimeOffsetInput";
		vi=document.getElementById(naid);
		CalendarTimeOffsetInputArray[rindex]=vi;
		CalendarTimeOffsetArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onCalendarTimeOffsetInputChanged);
	}
}

function DoDeletePlaylistMulti(obj) {
	var dji=PlaylistMultiRemoveButtonArray.indexOf(obj);
	NumOfPlaylists--;
	var t=NumOfPlaylistsHidden.onchange;
	NumOfPlaylistsHidden.onchange=null;
	NumOfPlaylistsHidden.value=NumOfPlaylists;
	SetObjCookie(NumOfPlaylistsHidden);
	NumOfPlaylistsHidden.onchange=t;
	for(var i=dji;i<NumOfPlaylists;i++) {
		PlaylistMultiSymNameInputArray[i].value=PlaylistMultiSymNameInputArray[i+1].value;
		PlaylistMultiSymNameArray[i]=PlaylistMultiSymNameArray[i+1];
		SetObjCookie(PlaylistMultiSymNameInputArray[i]);

		PlaylistMultiFileInputArray[i].value=PlaylistMultiFileInputArray[i+1].value;
		PlaylistMultiFileArray[i]=PlaylistMultiFileArray[i+1];
		SetObjCookie(PlaylistMultiFileInputArray[i]);
	}
	var vi=PlaylistMultiSymNameInputArray.pop();
	EraseObjCookie(vi);
	var vi=PlaylistMultiFileInputArray.pop();
	EraseObjCookie(vi);
	var vi=PlaylistMultiRemoveButtonArray.pop();
	EraseObjCookie(vi);
	createCookie("NumOfPlaylistsHidden",NumOfDJs);
	MultiPlaylistSpanUpdate();
}

function onPlaylistMultiRemoveButtonClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	DoDeletePlaylistMulti(obj);
	DoUpdate();
}

function onPlaylistMultiCalendarAddButtonClicked(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var dji=PlaylistMultiCalendarAddButtonArray.indexOf(obj);
	var PMSymNameObj=PlaylistMultiSymNameInputArray[dji];
	if(PMSymNameObj==null || PMSymNameObj==undefined)return;
	if(PMSymNameObj.value=="")return;
	DoAddCalendarEvent();
	DoUpdate();
	var CalEvtTypeObj=CalendarEventTypeSelectArray[NumOfCalendarEvents-1];
	var CalPlaylistNameObj=CalendarPlaylistNameInputArray[NumOfCalendarEvents-1];
	if(CalPlaylistNameObj!=null && CalPlaylistNameObj!=undefined && CalEvtTypeObj!=null && CalEvtTypeObj!=undefined) {
		if(dji>-1) {
			PushUpdateKill();
			SetObjectValue(CalEvtTypeObj,"playlist");
			CallObjectChanged(CalEvtTypeObj);
			SetObjectValue(CalPlaylistNameObj,PMSymNameObj.value);
			CallObjectChanged(CalPlaylistNameObj);
			PopUpdateKill();
			DoUpdate();
			alert("The playlist has been added to the Calendar event list.  Double check the name matches and to set the desired run-time(s).");
		}
	}
}

function onPlaylistMultiSymNameInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=PlaylistMultiSymNameInputArray.indexOf(obj)
	if(i<0)return;
	var OldSymName=PlaylistMultiSymNameArray[i];
	PlaylistMultiSymNameArray[i]=(PlaylistMultiSymNameInputArray[i].value);
	SetObjCookie(PlaylistMultiSymNameInputArray[i]);
	var NewSymName=PlaylistMultiSymNameArray[i];
	if(OldSymName!=NewSymName) {
		for(var i=0;i<NumOfCalendarEvents;i++) {
			if(CalendarPlaylistNameArray[i]==OldSymName) {
				CalendarPlaylistNameArray[i]=NewSymName;
				SetObjectValue(CalendarPlaylistNameInputArray[i],NewSymName);
				SetObjCookie(CalendarPlaylistNameInputArray[i]);
				PushUpdateKill();
				CallObjectChanged(CalendarPlaylistNameInputArray[i]);
				PopUpdateKill();
			}
		}
		DoUpdate();
	}
}

function onPlaylistMultiFileInputChanged(w) {
	var evt=w || window.event;
	var obj=evt.target || evt.srcElement;
	var i=PlaylistMultiFileInputArray.indexOf(obj)
	if(i<0)return;
	PlaylistMultiFileArray[i]=(PlaylistMultiFileInputArray[i].value);
	SetObjCookie(PlaylistMultiFileInputArray[i]);
	DoUpdate();
}

function MultiPlaylistSpanUpdate() {
	delete PlaylistMultiRemoveButtonArray;
	delete PlaylistMultiSymNameInputArray;
	delete PlaylistMultiFileInputArray;
	delete PlaylistMultiCalendarAddButtonArray;
	var fark="";
	MultiPlaylistSpan.innerHTML=fark;
	PlaylistMultiRemoveButtonArray = new Array(NumOfPlaylists);
	PlaylistMultiSymNameInputArray = new Array(NumOfPlaylists);
	PlaylistMultiFileInputArray = new Array(NumOfPlaylists);
	PlaylistMultiCalendarAddButtonArray = new Array(NumOfPlaylists);
	for(var rindex=0;rindex<NumOfPlaylists;rindex++) {
		fark+="<br/><br/>";
		var naid="PlaylistMulti"+(rindex)+"RemoveButton";
		fark+="<input name=\""+naid+"\" id=\""+naid+"\" type=\"button\" class=\"button\" value=\"Remove Playlist\"/>";
		fark+="<table>";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>";
		var naid="PlaylistMulti"+(rindex)+"SymNameInput";
		fark+="Symbolic&nbsp;Name</td><td><input name=\""+naid+"\" id=\""+naid+"\"/>";
		fark+="</td></tr>";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>";
		var naid="PlaylistMulti"+(rindex)+"CalendarAddButton";
		fark+="<input name=\""+naid+"\" id=\""+naid+"\" type=\"button\" class=\"button\" value=\"Calendar\"/></td><td>Add playlist to the calendar.";
		fark+="</td></tr>";

		fark+="<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>";
		var naid="PlaylistMulti"+(rindex)+"FileInput";
		fark+="File</td><td><input name=\""+naid+"\" id=\""+naid+"\"/>";
		fark+="</td></tr>";

		fark+="</table>";
	}

	MultiPlaylistSpan.innerHTML=fark;
	for(var rindex=0;rindex<NumOfPlaylists;rindex++) {
		var vi;

		var naid="PlaylistMulti"+(rindex)+"RemoveButton";
		vi=document.getElementById(naid);
		PlaylistMultiRemoveButtonArray[rindex]=vi;
		GetObjCookie(vi);
		AETFC(vi,onPlaylistMultiRemoveButtonClicked);

		var naid="PlaylistMulti"+(rindex)+"SymNameInput";
		vi=document.getElementById(naid);
		PlaylistMultiSymNameInputArray[rindex]=vi;
		PlaylistMultiSymNameArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onPlaylistMultiSymNameInputChanged);

		var naid="PlaylistMulti"+(rindex)+"CalendarAddButton";
		vi=document.getElementById(naid);
		PlaylistMultiCalendarAddButtonArray[rindex]=vi;
		GetObjCookie(vi);
		AETFC(vi,onPlaylistMultiCalendarAddButtonClicked);

		var naid="PlaylistMulti"+(rindex)+"FileInput";
		vi=document.getElementById(naid);
		PlaylistMultiFileInputArray[rindex]=vi;
		PlaylistMultiFileArray[rindex]=GetObjCookie(vi);
		AETFC(vi,onPlaylistMultiFileInputChanged);
	}
}

function MultiPointSpanUpdate(nos) {
	delete EndPointNameInputArray;
	delete EndPointPathInputArray;
	delete EndPointMaxUserInputArray;
	delete EndPointTypeSelectArray;
	delete EndPointAACFormatSelectArray;
	delete EndPointMP3QualitySelectArray;
	delete EndPointMP3ModeSelectArray;
	delete EndPointBitrateInputArray;
	delete EndPointSamplerateInputArray;
	delete EndPointNumchnsInputArray;
	delete EndPointAuthHashInputArray;
	var fark="";
	MultiPointSpan.innerHTML=fark;
	var narf=nos;
	if(nos<=0){narf=1;}
	EndPointNameInputArray = new Array(narf);
	EndPointPathInputArray = new Array(narf);
	EndPointMaxUserInputArray = new Array(NumOfEndPoints);
	EndPointTypeSelectArray = new Array(narf);
	EndPointAACFormatSelectArray = new Array(narf);
	EndPointMP3QualitySelectArray = new Array(narf);
	EndPointMP3ModeSelectArray = new Array(narf);
	EndPointBitrateInputArray = new Array(narf);
	EndPointSamplerateInputArray = new Array(narf);
	EndPointNumchnsInputArray = new Array(narf);
	EndPointAuthHashInputArray = new Array(narf);
	fark+="<tr><td><table><tbody>";

	for(var i=0;i<narf;i++) {
		var rindex=i+1;
		if(Mode==2) {
			fark+="<tr><td class=\"title\">"+(rindex>1 ? "<br/>" : "")+"Endpoint&nbsp;#"+rindex+":</td></tr>";
			fark+="<tr><td class=\"ConfigTableDescTD\">";

			var naid="EndPoint"+(rindex)+"NameInput";
			fark+="Name</td><td><input name=\""+naid+"\" id=\""+naid+"\"/><br/>";
			fark+="</td></tr><tr><td class=\"ConfigTableDescTD\">";

			var naid="EndPoint"+(rindex)+"PathInput";
			fark+="Path</td><td><input name=\""+naid+"\" id=\""+naid+"\"/><br/>";
			fark+="</td></tr><tr><td class=\"ConfigTableDescTD\">";

			var naid="EndPoint"+(rindex)+"MaxUserInput";
			fark+="Max&nbsp;Listeners</td><td><input name=\""+naid+"\" id=\""+naid+"\"/><br/>";
			fark+="</td></tr><tr><td class=\"ConfigTableDescTD\">";

			var naid="EndPoint"+(rindex)+"AuthHashInput";
			fark+="Auth&nbsp;Hash</td><td><input name=\""+naid+"\" id=\""+naid+"\"/><br/>";
			fark+="</td></tr><tr>";//<td class=\"ConfigTableDescTD\">";
		}

		fark+="<tr><td class=\"ConfigTableDescTD\">";
		var naid="EndPoint"+(rindex)+"BitrateInput";
		fark+="Bitrate</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"96000\"/><br/></td></tr>";
		var naid="EndPoint"+(rindex)+"SamplerateInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">Samplerate</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"44100\"/><br/></td></tr>";
		var naid="EndPoint"+(rindex)+"NumchnsInput";
		fark+="<tr><td class=\"ConfigTableDescTD\">#&nbsp;of&nbsp;Channels</td><td><input name=\""+naid+"\" id=\""+naid+"\" value=\"2\"/><br/></td></tr>";

		fark+="<tr><td class=\"ConfigTableDescTD\">";
		var naid="EndPoint"+(rindex)+"TypeSelect";
		fark+="Type</td><td><select name=\""+naid+"\" id=\""+naid+"\"/><option value=\"aacp\">aac+</option><option value=\"mp3\">mp3</option></select><br/></td></tr>";

		fark+="<tr><td colspan=\"3\" class=\"ConfigTableDescTD\">";
		var naid="EndPoint"+(rindex)+"AACFormatSpan";
		fark+="<span name=\""+naid+"\" id=\""+naid+"\">";
		fark+="<table colspan\"2\" width=\"100%\"><tbody><tr><td class=\"ConfigTableDescTD\">";
		var naid="EndPoint"+(rindex)+"AACFormatSelect";
		fark+="AAC&nbsp;Format</td><td style=\"text-align:left;\"><select name=\""+naid+"\" id=\""+naid+"\"/><option value=\"0\">ADTS</option><option value=\"1\">ADIF</option><option value=\"2\">LATM</option><option value=\"3\">LOAS</option><option value=\"4\">RAW</option><option value=\"5\">ADTS_MP4</option></select><br/>";
		fark+="</span>";
		fark+="</td></tr></tbody></table>";
		fark+="</td></tr>";

		fark+="<tr><td colspan=\"3\" class=\"ConfigTableDescTD\">";
		var naid="EndPoint"+(rindex)+"MP3FormatSpan";
		fark+="<span name=\""+naid+"\" id=\""+naid+"\" style=\"visibility: hidden; display: none;\">";
		var naid="EndPoint"+(rindex)+"MP3QualitySelect";
		fark+="<table><tbody><tr><td class=\"ConfigTableDescTD\">";
		fark+="MP3&nbsp;Quality</td><td style=\"text-align:left;\"><select name=\""+naid+"\" id=\""+naid+"\"/><option value=\"0\">Fast</option><option value=\"1\">High Quality</option></select><br/>";
		fark+="</td></tr><tr><td class=\"ConfigTableDescTD\">";
		var naid="EndPoint"+(rindex)+"MP3ModeSelect";
		fark+="MP3&nbsp;Mode</td><td style=\"text-align:left;\"><select name=\""+naid+"\" id=\""+naid+"\"/><option value=\"0\">Constant Bitrate</option><option value=\"1\">Variable Bitrate - HighQuality</option><option value=\"2\">Variable Bitrate - SomewhatHighQuality</option><option value=\"3\">Variable Bitrate - MediumQuality</option><option value=\"4\">Variable Bitrate - SomewhatLowQuality</option><option value=\"5\">Variable Bitrate - LowQuality</option></select><br/>";
		fark+="</span>";
		fark+="</td></tr></tbody></table>";
		fark+="</td></tr>";
	}

	fark+="</td></tr></tbody></table>";
	MultiPointSpan.innerHTML=fark;
	for(var i=0;i<narf;i++) {
		var rindex=i+1;

		var naid;
		var vi;

		if(Mode==2) {
			naid="EndPoint"+(rindex)+"NameInput";
			vi=document.getElementById(naid);
			EndPointNameInputArray[i]=vi;
			vi.value="endpoint"+i;
			GetObjCookie(vi);
			AETFC(vi,onEndPointGenericObjectChanged);

			naid="EndPoint"+(rindex)+"PathInput";
			vi=document.getElementById(naid);
			EndPointPathInputArray[i]=vi;
			vi.value="/listen"+rindex;
			GetObjCookie(vi);
			AETFC(vi,onEndPointGenericObjectChanged);
			
			naid="EndPoint"+(rindex)+"MaxUserInput";
			vi=document.getElementById(naid);
			EndPointMaxUserInputArray[i]=vi;
			vi.value="";
			GetObjCookie(vi);
			AETFC(vi,onEndPointGenericObjectChanged);
		}

		naid="EndPoint"+(rindex)+"TypeSelect";
		vi=document.getElementById(naid);
		EndPointTypeSelectArray[i]=vi;
		GetObjCookie(vi);
		DoEndPointTypeSelectUpdate(vi);
		AETFC(vi,onEndPointTypeSelectChanged);

		naid="EndPoint"+(rindex)+"AACFormatSelect";
		vi=document.getElementById(naid);
		EndPointAACFormatSelectArray[i]=vi;
		GetObjCookie(vi);
		AETFC(vi,onEndPointGenericObjectChanged);

		naid="EndPoint"+(rindex)+"MP3QualitySelect";
		vi=document.getElementById(naid);
		EndPointMP3QualitySelectArray[i]=vi;
		GetObjCookie(vi);
		AETFC(vi,onEndPointGenericObjectChanged);

		naid="EndPoint"+(rindex)+"MP3ModeSelect";
		vi=document.getElementById(naid);
		EndPointMP3ModeSelectArray[i]=vi;
		GetObjCookie(vi);
		AETFC(vi,onEndPointGenericObjectChanged);

		naid="EndPoint"+(rindex)+"BitrateInput";
		vi=document.getElementById(naid);
		EndPointBitrateInputArray[i]=vi;
		GetObjCookie(vi);
		AETFC(vi,onEndPointGenericObjectChanged);

		naid="EndPoint"+(rindex)+"SamplerateInput";
		vi=document.getElementById(naid);
		EndPointSamplerateInputArray[i]=vi;
		GetObjCookie(vi);
		AETFC(vi,onEndPointGenericObjectChanged);

		naid="EndPoint"+(rindex)+"NumchnsInput";
		vi=document.getElementById(naid);
		EndPointNumchnsInputArray[i]=vi;
		GetObjCookie(vi);
		AETFC(vi,onEndPointGenericObjectChanged);

		if(Mode==2) {
			naid="EndPoint"+(rindex)+"AuthHashInput";
			vi=document.getElementById(naid);
			EndPointAuthHashInputArray[i]=vi;
			GetObjCookie(vi);
			AETFC(vi,onEndPointGenericObjectChanged);
		}
	}
}

function LoadHelpTextDB() {
	HelperTextDBKeysArray = new Array();
	HelperTextDBValuesArray = new Array();
	var GenErrMess="The SHOUTcast 2 Cofiguration Builder was unable to locate or load the help database.";
	try {
		HelperXMLHTTP=new ActiveXObject("Microsoft.XMLHTTP");
	}
	catch(e) {
		HelperXMLHTTP=new XMLHttpRequest();
	}

	if(HelperXMLHTTP==null || HelperXMLHTTP==undefined) {
		HelperTextDBKeysArray.push("");
		HelperTextDBValuesArray.push(GenErrMess+"<br/><br/>AJAX API not supported in this browser.");
		alert(GenErrMess);
		return;
	}
	var tdl=window.location.href;
	tdl=tdl.split("/");
	tdl.pop();
	tdl.push("db/config_builder_help.txt");
	tdl=tdl.join("/");
	HelperXMLHTTP.abort();
	HelperXMLHTTP.open("GET",tdl,false);
	try {
		HelperXMLHTTP.send(null);
	}catch(e) {
		HelperTextDBKeysArray.push("");
		HelperTextDBValuesArray.push(GenErrMess+"<br/><br/>"+e);
		alert(GenErrMess);
		return;
	}
	var rt="";
	try {
		rt=HelperXMLHTTP.responseText;
	}
	catch(e) {
		HelperTextDBKeysArray.push("");
		HelperTextDBValuesArray.push(GenErrMess+"<br/><br/>"+e);
		alert(GenErrMess);
		return;
	}

	if(rt=="") {
		HelperTextDBKeysArray.push("");
		HelperTextDBValuesArray.push(GenErrMess+"<br/><br/>Empty database.");
		alert(GenErrMess);
		return;
	}
	rt=rt.split("\n");

	for(var i=0;i<rt.length;i++) {
		var tts=rt[i];
		if(tts.indexOf(";")==0)continue;
		if(tts.indexOf("//")==0)continue;
		if(tts=="\r\n")continue;
		if(tts=="\n")continue;
		if(tts=="\r")continue;
		tts=tts.split(",");
		HelperTextDBKeysArray.push(tts.shift());
		HelperTextDBValuesArray.push(tts.join(","));
	}
}

function ConfigFileReadData(f) {
	SetDefaults();
	PutAllSettings(f);
}

function ConfigFileRead(f) {
	ConfigFileReadData(f.target.result);
}

function IEAlt(obj) {
	var c=0;
	var fso=null;
	var l="";
	try {
		fso = new ActiveXObject("Scripting.FileSystemObject");
	}
	catch(e) {
		alert(e);
		return;
	}
	var f=obj.value;
	if(fso.FileExists(f)) {
		f=fso.OpenTextFile(f,1);
		while(!(f.AtEndOfStream)) {
			c++;
			var a=f.ReadAll();
			l+=a;
		}
		f.Close();
		ConfigFileReadData(l);
	}
}

function DoConfigFileRead(obj) {
	try {
		var reader = new FileReader();
		reader.onload = ConfigFileRead;
		reader.readAsText(obj.files[0]);
		return;
	}
	catch(e) {
		IEAlt(obj);
	}
}

function onUploadConfigButtonClicked() {
	DoConfigFileRead(document.getElementById("UploadConfigFile"));
}

function InitDownloadifier() {
	if(typeof(MooTools) != 'undefined') {
		Element.implement({
			downloadify: function(options) {
				options = $extend(Downloadify.defaultOptions,options);
				return this.store('Downloadify',Downloadify.create(this,options));
			}
		});
	}

	window.addEvent('domready',function() {
		$('DownloadDNASConfigButton').downloadify({
			filename: function() {
				return DNASConfFile;
			},
			data: function() {
				return scscl;
			},
			onComplete: function() {
				alert('The file has been saved.');
			},
			onCancel: function() {
			},
			onError: function() {
				alert('An error occured while initilizing local file download functions.');
			},
			transparent: false,
			swf: 'res/downloadify.swf',
			downloadImage: 'res/dl_button.png',
			width: 82,
			height: 19,
			transparent: true,
			append: false
		});
	});

	window.addEvent('domready',function() {
		$('DownloadTransConfigButton').downloadify({
			filename: function() {
				return TransConfFile;
			},
			data: function() {
				return sctcl;
			},
			onComplete: function() {
				alert('The file has been saved.');
			},
			onCancel: function() {
			},
			onError: function() {
				alert('An error occured while initilizing local file download functions.'); 
			},
			transparent: false,
			swf: 'res/downloadify.swf',
			downloadImage: 'res/dl_button.png',
			width: 82,
			height: 19,
			transparent: true,
			append: false
		});
	});

	window.addEvent('domready',function() {
		$('DownloadCalendarConfigButton').downloadify({
			filename: function() {
				return CalendarFile;
			},
			data: function(){
				return scccl;
			},
			onComplete: function() {
				alert('The file has been saved.');
			},
			onCancel: function() {
			},
			onError: function() {
				alert('An error occured while initilizing local file download functions.');
			},
			transparent: false,
			swf: 'res/downloadify.swf',
			downloadImage: 'res/dl_button.png',
			width: 82,
			height: 19,
			transparent: true,
			append: false
		});
	});

	window.addEvent('domready',function() {
		$('DownloadSettingsButton').downloadify({
			filename: function() {
				return 'config_builder_settings.txt';
			},
			data: function() {
				return GetAllSettings();
			},
			onComplete: function() {
				alert('The file has been saved.');
			},
			onCancel: function() {
			},
			onError: function() {
				if(!GetAllSettings()) {
					alert('There are no differences against the default settings.  No backup file will be created.');
				}
				else {
					alert('An error occured while initilizing local file download functions.');
				}
			},
			transparent: false,
			swf: 'res/downloadify.swf',
			downloadImage: 'res/dl_button.png',
			width: 82,
			height: 19,
			transparent: true,
			append: false
		});
	});

	window.addEvent('domready',function() {
		$('DownloadDNASLauncherFileButton').downloadify({
			filename: function() {
				return scssfn;
			},
			data: function() {
				return scssl;
			},
			onComplete: function() {
				alert('The file has been saved.');
			},
			onCancel: function() {
			},
			onError: function() {
				alert('An error occured while initilizing local file download functions.');
			},
			transparent: false,
			swf: 'res/downloadify.swf',
			downloadImage: 'res/dl_button.png',
			width: 82,
			height: 19,
			transparent: true,
			append: false
		});
	});

	window.addEvent('domready',function() {
		$('DownloadTransLauncherFileButton').downloadify({
			filename: function() {
				return sctsfn;
			},
			data: function() {
				return sctsl;
			},
			onComplete: function() {
				alert('The file has been saved.');
			},
			onCancel: function() {
			},
			onError: function() {
				alert('An error occured while initilizing local file download functions.');
			},
			transparent: false,
			swf: 'res/downloadify.swf',
			downloadImage: 'res/dl_button.png',
			width: 82,
			height: 19,
			transparent: true,
			append: false
		});
	});
}

function DoInit() {
	PushUpdateKill();
	SetDefaults();

	myScrollTable = document.getElementById('myScrollTable');
	HelperTable = document.getElementById('HelperTable');
	HelperSpan=document.getElementById("HelperSpan");

	SCServLinesTextArea=document.getElementById("SCServLinesTextArea");
	SCTransLinesTextArea=document.getElementById("SCTransLinesTextArea");
	SCCalendarLinesTextArea=document.getElementById("SCCalendarLinesTextArea");

	try{document.querySelector("#SCServLinesTextArea").spellcheck = false;}catch(e) {
		try{document.getElementByID("SCServLinesTextArea").spellcheck=false;}catch(e) {}
	}
	try{document.querySelector("#SCTransLinesTextArea").spellcheck = false;}catch(e) {
		try{document.getElementByID("SCTransLinesTextArea").spellcheck=false;}catch(e) {}
	}
	try{document.querySelector("#SCCalendarLinesTextArea").spellcheck = false;}catch(e) {
		try{document.getElementByID("SCCalendarLinesTextArea").spellcheck=false;}catch(e) {}
	}

	NumOfPlaylistsHidden=document.getElementById("NumOfPlaylistsHidden");
	NumOfPlaylists=GetObjCookie(NumOfPlaylistsHidden)*1;
	AETFC(NumOfPlaylistsHidden,onNumOfPlaylistsHiddenChanged);

	MultiPlaylistSpan=document.getElementById("MultiPlaylistSpan");
	MultiPlaylistSpanUpdate();

	AddPlaylistButton=document.getElementById("AddPlaylistButton");
	AETFC(AddPlaylistButton,onAddPlaylistButtonClicked);

	MultiPointSpan=document.getElementById("MultiPointSpan");
	DefaultAuthHashTR=document.getElementById("DefaultAuthHashTR");
	NumOfEndPointsTR=document.getElementById("NumOfEndPointsTR");

	PlatformSelect=document.getElementById("PlatformSelect");
	Platform=GetObjCookie(PlatformSelect)*1;
	AETFC(PlatformSelect,onPlatformSelectChanged);

	DNASBasePathInput=document.getElementById("DNASBasePathInput");
	DNASBasePath=GetObjCookie(DNASBasePathInput);
	AETFC(DNASBasePathInput,onDNASBasePathInputChanged);

	TranscoderBasePathInput=document.getElementById("TranscoderBasePathInput");
	TranscoderBasePath=GetObjCookie(TranscoderBasePathInput);
	AETFC(TranscoderBasePathInput,onTranscoderBasePathInputChanged);

	DNASConfFileInput=document.getElementById("DNASConfFileInput");
	DNASConfFile=GetObjCookie(DNASConfFileInput);
	AETFC(DNASConfFileInput,onDNASConfFileInputChanged);

	TransConfFileInput=document.getElementById("TransConfFileInput");
	TransConfFile=GetObjCookie(TransConfFileInput);
	AETFC(TransConfFileInput,onTransConfFileInputChanged);

	BufferTypeSelect=document.getElementById("BufferTypeSelect");
	BufferType=GetObjCookie(BufferTypeSelect)*1;
	AETFC(BufferTypeSelect,onBufferTypeSelectChanged);

	AdaptiveBufferSizeTR=document.getElementById("AdaptiveBufferSizeTR");
	FixedBufferSizeTR=document.getElementById("FixedBufferSizeTR");
	DoBufferTypeUpdate(BufferType);

	AdaptiveBufferSizeInput=document.getElementById("AdaptiveBufferSizeInput");
	AdaptiveBufferSize=GetObjCookie(AdaptiveBufferSizeInput)*1;
	AETFC(AdaptiveBufferSizeInput,onAdaptiveBufferSizeInputChanged);

	FixedBufferSizeInput=document.getElementById("FixedBufferSizeInput");
	FixedBufferSize=GetObjCookie(FixedBufferSizeInput)*1;
	AETFC(FixedBufferSizeInput,onFixedBufferSizeInputChanged);

	BufferHardLimitInput=document.getElementById("BufferHardLimitInput");
	BufferHardLimit=GetObjCookie(BufferHardLimitInput)*1;
	AETFC(BufferHardLimitInput,onBufferHardLimitInputChanged);

	MaxHeaderLineSizeInput=document.getElementById("MaxHeaderLineSizeInput");
	MaxHeaderLineSize=GetObjCookie(MaxHeaderLineSizeInput)*1;
	AETFC(MaxHeaderLineSizeInput,onMaxHeaderLineSizeInputChanged);

	MaxHeaderLineCountInput=document.getElementById("MaxHeaderLineCountInput");
	MaxHeaderLineCount=GetObjCookie(MaxHeaderLineCountInput)*1;
	AETFC(MaxHeaderLineCountInput,onMaxHeaderLineCountInputChanged);

	NameLookupsCheckBox=document.getElementById("NameLookupsCheckBox");
	NameLookups=GetObjCookie(NameLookupsCheckBox);
	AETFC(NameLookupsCheckBox,onNameLookupsCheckBoxClicked);

	ModeSelect=document.getElementById("ModeSelect");
	Mode=GetObjCookie(ModeSelect)*1;
	AETFC(ModeSelect,onModeSelectChanged);

	EnableLoggingCheckBox=document.getElementById("EnableLoggingCheckBox");
	EnableLogging=GetObjCookie(EnableLoggingCheckBox);
	AETFC(EnableLoggingCheckBox,onEnableLoggingCheckBoxClicked);

	ScreenlogCheckBox=document.getElementById("ScreenlogCheckBox");
	Screenlog=GetObjCookie(ScreenlogCheckBox);
	AETFC(ScreenlogCheckBox,onScreenlogCheckBoxClicked);

	DNASLogFileInput=document.getElementById("DNASLogFileInput");
	DNASLogFile=GetObjCookie(DNASLogFileInput);
	AETFC(DNASLogFileInput,onDNASLogFileInputChanged);

	TransLogFileInput=document.getElementById("TransLogFileInput");
	TransLogFile=GetObjCookie(TransLogFileInput);
	AETFC(TransLogFileInput,onTransLogFileInputChanged);

	W3CLoggingCheckBox=document.getElementById("W3CLoggingCheckBox");
	W3CLogging=GetObjCookie(W3CLoggingCheckBox);
	AETFC(W3CLoggingCheckBox,onW3CLoggingCheckBoxClicked);

	W3CLogFileInput=document.getElementById("W3CLogFileInput");
	W3CLogFile=GetObjCookie(W3CLogFileInput);
	AETFC(W3CLogFileInput,onW3CLogFileInputChanged);

	WebClientDebugCheckBox=document.getElementById("WebClientDebugCheckBox");
	WebClientDebug=GetObjCookie(WebClientDebugCheckBox);
	AETFC(WebClientDebugCheckBox,onWebClientDebugCheckBoxClicked);

	YP1DebugCheckBox=document.getElementById("YP1DebugCheckBox");
	YP1Debug=GetObjCookie(YP1DebugCheckBox);
	AETFC(YP1DebugCheckBox,onYP1DebugCheckBoxClicked);

	YP2DebugCheckBox=document.getElementById("YP2DebugCheckBox");
	YP2Debug=GetObjCookie(YP2DebugCheckBox);
	AETFC(YP2DebugCheckBox,onYP2DebugCheckBoxClicked);

	SHOUTcastSourceDebugCheckBox=document.getElementById("SHOUTcastSourceDebugCheckBox");
	SHOUTcastSourceDebug=GetObjCookie(SHOUTcastSourceDebugCheckBox);
	AETFC(SHOUTcastSourceDebugCheckBox,onSHOUTcastSourceDebugCheckBoxClicked);

	UVOX2SourceDebugCheckBox=document.getElementById("UVOX2SourceDebugCheckBox");
	UVOX2SourceDebug=GetObjCookie(UVOX2SourceDebugCheckBox);
	AETFC(UVOX2SourceDebugCheckBox,onUVOX2SourceDebugCheckBoxClicked);

	SHOUTcast1ClientDebugCheckBox=document.getElementById("SHOUTcast1ClientDebugCheckBox");
	SHOUTcast1ClientDebug=GetObjCookie(SHOUTcast1ClientDebugCheckBox);
	AETFC(SHOUTcast1ClientDebugCheckBox,onSHOUTcast1ClientDebugCheckBoxClicked);

	SHOUTcast2ClientDebugCheckBox=document.getElementById("SHOUTcast2ClientDebugCheckBox");
	SHOUTcast2ClientDebug=GetObjCookie(SHOUTcast2ClientDebugCheckBox);
	AETFC(SHOUTcast2ClientDebugCheckBox,onSHOUTcast2ClientDebugCheckBoxClicked);

	RelaySHOUTcastDebugCheckBox=document.getElementById("RelaySHOUTcastDebugCheckBox");
	RelaySHOUTcastDebug=GetObjCookie(RelaySHOUTcastDebugCheckBox);
	AETFC(RelaySHOUTcastDebugCheckBox,onRelaySHOUTcastDebugCheckBoxClicked);

	RelayUVOXDebugCheckBox=document.getElementById("RelayUVOXDebugCheckBox");
	RelayUVOXDebug=GetObjCookie(RelayUVOXDebugCheckBox);
	AETFC(RelayUVOXDebugCheckBox,onRelayUVOXDebugCheckBoxClicked);

	RelayDebugCheckBox=document.getElementById("RelayDebugCheckBox");
	RelayDebug=GetObjCookie(RelayDebugCheckBox);
	AETFC(RelayDebugCheckBox,onRelayDebugCheckBoxClicked);

	StreamDataDebugCheckBox=document.getElementById("StreamDataDebugCheckBox");
	StreamDataDebug=GetObjCookie(StreamDataDebugCheckBox);
	AETFC(StreamDataDebugCheckBox,onStreamDataDebugCheckBoxClicked);

	HTTPStyleDebugCheckBox=document.getElementById("HTTPStyleDebugCheckBox");
	HTTPStyleDebug=GetObjCookie(HTTPStyleDebugCheckBox);
	AETFC(HTTPStyleDebugCheckBox,onHTTPStyleDebugCheckBoxClicked);

	StatsDebugCheckBox=document.getElementById("StatsDebugCheckBox");
	StatsDebug=GetObjCookie(StatsDebugCheckBox);
	AETFC(StatsDebugCheckBox,onStatsDebugCheckBoxClicked);

	MicroServerDebugCheckBox=document.getElementById("MicroServerDebugCheckBox");
	MicroServerDebug=GetObjCookie(MicroServerDebugCheckBox);
	AETFC(MicroServerDebugCheckBox,onMicroServerDebugCheckBoxClicked);

	ThreadRunnerDebugCheckBox=document.getElementById("ThreadRunnerDebugCheckBox");
	ThreadRunnerDebug=GetObjCookie(ThreadRunnerDebugCheckBox);
	AETFC(ThreadRunnerDebugCheckBox,onThreadRunnerDebugCheckBoxClicked);

	RTMPClientDebugCheckBox=document.getElementById("RTMPClientDebugCheckBox");
	RTMPClientDebug=GetObjCookie(RTMPClientDebugCheckBox);
	AETFC(RTMPClientDebugCheckBox,onRTMPClientDebugCheckBoxClicked);

	ShuffleDebugCheckBox=document.getElementById("ShuffleDebugCheckBox");
	ShuffleDebug=GetObjCookie(ShuffleDebugCheckBox);
	AETFC(ShuffleDebugCheckBox,onShuffleDebugCheckBoxClicked);

	SHOUTcastDebugCheckBox=document.getElementById("SHOUTcastDebugCheckBox");
	SHOUTcastDebug=GetObjCookie(SHOUTcastDebugCheckBox);
	AETFC(SHOUTcastDebugCheckBox,onSHOUTcastDebugCheckBoxClicked);

	UVOXDebugCheckBox=document.getElementById("UVOXDebugCheckBox");
	UVOXDebug=GetObjCookie(UVOXDebugCheckBox);
	AETFC(UVOXDebugCheckBox,onUVOXDebugCheckBoxClicked);

	GainDebugCheckBox=document.getElementById("GainDebugCheckBox");
	GainDebug=GetObjCookie(GainDebugCheckBox);
	AETFC(GainDebugCheckBox,onGainDebugCheckBoxClicked);

	PlaylistDebugCheckBox=document.getElementById("PlaylistDebugCheckBox");
	PlaylistDebug=GetObjCookie(PlaylistDebugCheckBox);
	AETFC(PlaylistDebugCheckBox,onPlaylistDebugCheckBoxClicked);

	MP3EncDebugCheckBox=document.getElementById("MP3EncDebugCheckBox");
	MP3EncDebug=GetObjCookie(MP3EncDebugCheckBox);
	AETFC(MP3EncDebugCheckBox,onMP3EncDebugCheckBoxClicked);

	MP3DecDebugCheckBox=document.getElementById("MP3DecDebugCheckBox");
	MP3DecDebug=GetObjCookie(MP3DecDebugCheckBox);
	AETFC(MP3DecDebugCheckBox,onMP3DecDebugCheckBoxClicked);

	ResamplerDebugCheckBox=document.getElementById("ResamplerDebugCheckBox");
	ResamplerDebug=GetObjCookie(ResamplerDebugCheckBox);
	AETFC(ResamplerDebugCheckBox,onResamplerDebugCheckBoxClicked);

	RGCalcDebugCheckBox=document.getElementById("RGCalcDebugCheckBox");
	RGCalcDebug=GetObjCookie(RGCalcDebugCheckBox);
	AETFC(RGCalcDebugCheckBox,onRGCalcDebugCheckBoxClicked);

	APIDebugCheckBox=document.getElementById("APIDebugCheckBox");
	APIDebug=GetObjCookie(APIDebugCheckBox);
	AETFC(APIDebugCheckBox,onAPIDebugCheckBoxClicked);

	CalendarDebugCheckBox=document.getElementById("CalendarDebugCheckBox");
	CalendarDebug=GetObjCookie(CalendarDebugCheckBox);
	AETFC(CalendarDebugCheckBox,onCalendarDebugCheckBoxClicked);

	CaptureDebugCheckBox=document.getElementById("CaptureDebugCheckBox");
	CaptureDebug=GetObjCookie(CaptureDebugCheckBox);
	AETFC(CaptureDebugCheckBox,onCaptureDebugCheckBoxClicked);

	DJDebugCheckBox=document.getElementById("DJDebugCheckBox");
	DJDebug=GetObjCookie(DJDebugCheckBox);
	AETFC(DJDebugCheckBox,onDJDebugCheckBoxClicked);

	FlashPolicyServerDebugCheckBox=document.getElementById("FlashPolicyServerDebugCheckBox");
	FlashPolicyServerDebug=GetObjCookie(FlashPolicyServerDebugCheckBox);
	AETFC(FlashPolicyServerDebugCheckBox,onFlashPolicyServerDebugCheckBoxClicked);

	FileConverterDebugCheckBox=document.getElementById("FileConverterDebugCheckBox");
	FileConverterDebug=GetObjCookie(FileConverterDebugCheckBox);
	AETFC(FileConverterDebugCheckBox,onFileConverterDebugCheckBoxClicked);

	SourceRelayDebugCheckBox=document.getElementById("SourceRelayDebugCheckBox");
	SourceRelayDebug=GetObjCookie(SourceRelayDebugCheckBox);
	AETFC(SourceRelayDebugCheckBox,onSourceRelayDebugCheckBoxClicked);

	SourceAndEndpointManagerDebugCheckBox=document.getElementById("SourceAndEndpointManagerDebugCheckBox");
	SourceAndEndpointManagerDebug=GetObjCookie(SourceAndEndpointManagerDebugCheckBox);
	AETFC(SourceAndEndpointManagerDebugCheckBox,onSourceAndEndpointManagerDebugCheckBoxClicked);

	StreamTitleInput=document.getElementById("StreamTitleInput");
	StreamTitle=GetObjCookie(StreamTitleInput);
	AETFC(StreamTitleInput,onStreamTitleInputChanged);

	StreamURLInput=document.getElementById("StreamURLInput");
	StreamURL=GetObjCookie(StreamURLInput);
	AETFC(StreamURLInput,onStreamURLInputChanged);

	StreamGenreInput=document.getElementById("StreamGenreInput");
	StreamGenre=GetObjCookie(StreamGenreInput);
	AETFC(StreamGenreInput,onStreamGenreInputChanged);

	AIMInput=document.getElementById("AIMInput");
	AIM=GetObjCookie(AIMInput);
	AETFC(AIMInput,onAIMInputChanged);

	IRCInput=document.getElementById("IRCInput");
	IRC=GetObjCookie(IRCInput);
	AETFC(IRCInput,onIRCInputChanged);

	ICQInput=document.getElementById("ICQInput");
	ICQ=GetObjCookie(ICQInput);
	AETFC(ICQInput,onICQInputChanged);

	UseMetadataCheckBox=document.getElementById("UseMetadataCheckBox");
	UseMetadata=GetObjCookie(UseMetadataCheckBox);
	AETFC(UseMetadataCheckBox,onUseMetadataCheckBoxClicked);

	MetadataPatternInput=document.getElementById("MetadataPatternInput");
	MetadataPattern=GetObjCookie(MetadataPatternInput);
	AETFC(MetadataPatternInput,onMetadataPatternInputChanged);

	DisplayMetadataPatternInput=document.getElementById("DisplayMetadataPatternInput");
	DisplayMetadataPattern=GetObjCookie(DisplayMetadataPatternInput);
	AETFC(DisplayMetadataPatternInput,onDisplayMetadataPatternInputChanged);

	TitleFormatInput=document.getElementById("TitleFormatInput");
	TitleFormat=GetObjCookie(TitleFormatInput);
	AETFC(TitleFormatInput,onTitleFormatInputChanged);

	URLFormatInput=document.getElementById("URLFormatInput");
	URLFormat=GetObjCookie(URLFormatInput);
	AETFC(URLFormatInput,onURLFormatInputChanged);

	DNASPublicSelect=document.getElementById("DNASPublicSelect");
	DNASPublic=GetObjCookie(DNASPublicSelect);
	AETFC(DNASPublicSelect,onDNASPublicSelectChanged);

	TransPublicCheckBox=document.getElementById("TransPublicCheckBox");
	SCTransPublic=GetObjCookie(TransPublicCheckBox);
	AETFC(TransPublicCheckBox,onTransPublicCheckBoxClicked);

	MetaIntervalInput=document.getElementById("MetaIntervalInput");
	MetaInterval=GetObjCookie(MetaIntervalInput)*1;
	AETFC(MetaIntervalInput,onMetaIntervalInputChanged);

	YPAddrInput=document.getElementById("YPAddrInput");
	YPAddr=GetObjCookie(YPAddrInput);
	AETFC(YPAddrInput,onYPAddrInputChanged);

	YPPortInput=document.getElementById("YPPortInput");
	YPPort=GetObjCookie(YPPortInput)*1;
	AETFC(YPPortInput,onYPPortInputChanged);

	YPPathInput=document.getElementById("YPPathInput");
	YPPath=GetObjCookie(YPPathInput);
	AETFC(YPPathInput,onYPPathInputChanged);

	YPTimeoutInput=document.getElementById("YPTimeoutInput");
	YPTimeout=GetObjCookie(YPTimeoutInput)*1;
	AETFC(YPTimeoutInput,onYPTimeoutInputChanged);

	YPMaxRetriesInput=document.getElementById("YPMaxRetriesInput");
	YPMaxRetries=GetObjCookie(YPMaxRetriesInput)*1;
	AETFC(YPMaxRetriesInput,onYPMaxRetriesInputChanged);

	YPReportIntervalInput=document.getElementById("YPReportIntervalInput");
	YPReportInterval=GetObjCookie(YPReportIntervalInput)*1;
	AETFC(YPReportIntervalInput,onYPReportIntervalInputChanged);

	YPMinReportIntervalInput=document.getElementById("YPMinReportIntervalInput");
	YPMinReportInterval=GetObjCookie(YPMinReportIntervalInput)*1;
	AETFC(YPMinReportIntervalInput,onYPMinReportIntervalInputChanged);

	PortBaseInput=document.getElementById("PortBaseInput");
	PortBase=GetObjCookie(PortBaseInput);
	AETFC(PortBaseInput,onPortBaseInputChanged);

	DNASIPInput=document.getElementById("DNASIPInput");
	DNASIP=GetObjCookie(DNASIPInput);
	AETFC(DNASIPInput,onDNASIPInputChanged);

	SourceBindAddressInput=document.getElementById("SourceBindAddressInput");
	SourceBindAddress=GetObjCookie(SourceBindAddressInput);
	AETFC(SourceBindAddressInput,onSourceBindAddressInputChanged);

	DestinationBindAddressInput=document.getElementById("DestinationBindAddressInput");
	DestinationBindAddress=GetObjCookie(DestinationBindAddressInput);
	AETFC(DestinationBindAddressInput,onDestinationBindAddressInputChanged);

	TransAdminPortInput=document.getElementById("TransAdminPortInput");
	TransAdminPort=GetObjCookie(TransAdminPortInput)*1;
	AETFC(TransAdminPortInput,onTransAdminPortInputChanged);

	PasswordInput=document.getElementById("PasswordInput");
	Password=GetObjCookie(PasswordInput);
	AETFC(PasswordInput,onPasswordInputChanged);

	AdminPasswordInput=document.getElementById("AdminPasswordInput");
	AdminPassword=GetObjCookie(AdminPasswordInput);
	AETFC(AdminPasswordInput,onAdminPasswordInputChanged);

	VUImageDirectoryInput=document.getElementById("VUImageDirectoryInput");
	VUImageDirectory=GetObjCookie(VUImageDirectoryInput);
	AETFC(VUImageDirectoryInput,onVUImageDirectoryInputChanged);

	VUImageSuffixInput=document.getElementById("VUImageSuffixInput");
	VUImageSuffix=GetObjCookie(VUImageSuffixInput);
	AETFC(VUImageSuffixInput,onVUImageSuffixInputChanged);

	VUImageMimeTypeInput=document.getElementById("VUImageMimeTypeInput");
	VUImageMimeType=GetObjCookie(VUImageMimeTypeInput);
	AETFC(VUImageMimeTypeInput,onVUImageMimeTypeInputChanged);

	DNASFlashPolicyFileInput=document.getElementById("DNASFlashPolicyFileInput");
	DNASFlashPolicyFile=GetObjCookie(DNASFlashPolicyFileInput);
	AETFC(DNASFlashPolicyFileInput,onDNASFlashPolicyFileInputChanged);

	FlashPolicyFileInput=document.getElementById("FlashPolicyFileInput");
	FlashPolicyFile=GetObjCookie(FlashPolicyFileInput);
	AETFC(FlashPolicyFileInput,onFlashPolicyFileInputChanged);

	FlashPolicyServerPortInput=document.getElementById("FlashPolicyServerPortInput");
	FlashPolicyServerPort=GetObjCookie(FlashPolicyServerPortInput)*1;
	AETFC(FlashPolicyServerPortInput,onFlashPolicyServerPortInputChanged);

	MP3UnlockKeyNameInput=document.getElementById("MP3UnlockKeyNameInput");
	MP3UnlockKeyName=GetObjCookie(MP3UnlockKeyNameInput);
	AETFC(MP3UnlockKeyNameInput,onMP3UnlockKeyNameInputChanged);

	MP3UnlockKeyCodeInput=document.getElementById("MP3UnlockKeyCodeInput");
	MP3UnlockKeyCode=GetObjCookie(MP3UnlockKeyCodeInput);
	AETFC(MP3UnlockKeyCodeInput,onMP3UnlockKeyCodeInputChanged);

	DefaultAuthHashInput=document.getElementById("DefaultAuthHashInput");
	DefaultAuthHash=GetObjCookie(DefaultAuthHashInput);
	AETFC(DefaultAuthHashInput,onDefaultAuthHashInputChanged);

	BanFileInput=document.getElementById("BanFileInput");
	BanFile=GetObjCookie(BanFileInput);
	AETFC(BanFileInput,onBanFileInputChanged);

	RipFileInput=document.getElementById("RipFileInput");
	RipFile=GetObjCookie(RipFileInput);
	AETFC(RipFileInput,onRipFileInputChanged);

	RipOnlyCheckBox=document.getElementById("RipOnlyCheckBox");
	RipOnly=GetObjCookie(RipOnlyCheckBox);
	AETFC(RipOnlyCheckBox,onRipOnlyCheckBoxClicked);

	MaxListenersInput=document.getElementById("MaxListenersInput");
	MaxListeners=GetObjCookie(MaxListenersInput)*1;
	AETFC(MaxListenersInput,onMaxListenersInputChanged);

	ListenerTimeInput=document.getElementById("ListenerTimeInput");
	ListenerTime=GetObjCookie(ListenerTimeInput)*1;
	AETFC(ListenerTimeInput,onListenerTimeInputChanged);

	AutoDumpUsersCheckBox=document.getElementById("AutoDumpUsersCheckBox");
	AutoDumpUsers=GetObjCookie(AutoDumpUsersCheckBox);
	AETFC(AutoDumpUsersCheckBox,onAutoDumpUsersCheckBoxClicked);

	CalendarEnableRewriteCheckBox=document.getElementById("CalendarEnableRewriteCheckBox");
	CalendarEnableRewrite=GetObjCookie(CalendarEnableRewriteCheckBox);
	AETFC(CalendarEnableRewriteCheckBox,onCalendarEnableRewriteCheckBoxClicked);

	CalendarFileInput=document.getElementById("CalendarFileInput");
	CalendarFile=GetObjCookie(CalendarFileInput);
	AETFC(CalendarFileInput,onCalendarFileInputChanged);

	PlaylistFileInput=document.getElementById("PlaylistFileInput");
	PlaylistFile=GetObjCookie(PlaylistFileInput);
	AETFC(PlaylistFileInput,onPlaylistFileInputChanged);

	EnableShuffleCheckBox=document.getElementById("EnableShuffleCheckBox");
	EnableShuffle=GetObjCookie(EnableShuffleCheckBox);
	AETFC(EnableShuffleCheckBox,onEnableShuffleCheckBoxClicked);

	XFadeTimeInput=document.getElementById("XFadeTimeInput");
	XFadeTime=GetObjCookie(XFadeTimeInput);
	AETFC(XFadeTimeInput,onXFadeTimeInputChanged);

	XFadeThresholdInput=document.getElementById("XFadeThresholdInput");
	XFadeThreshold=GetObjCookie(XFadeThresholdInput);
	AETFC(XFadeThresholdInput,onXFadeThresholdInputChanged);

	PlaylistFolderInput=document.getElementById("PlaylistFolderInput");
	PlaylistFolder=GetObjCookie(PlaylistFolderInput);
	AETFC(PlaylistFolderInput,onPlaylistFolderInputChanged);

	PlaylistArchiveFolderInput=document.getElementById("PlaylistArchiveFolderInput");
	PlaylistArchiveFolder=GetObjCookie(PlaylistArchiveFolderInput);
	AETFC(PlaylistArchiveFolderInput,onPlaylistArchiveFolderInputChanged);

	DJPortInput=document.getElementById("DJPortInput");
	DJPort=GetObjCookie(DJPortInput)*1;
	AETFC(DJPortInput,onDJPortInputChanged);

	DJPort2Input=document.getElementById("DJPort2Input");
	DJPort2=GetObjCookie(DJPort2Input)*1;
	AETFC(DJPort2Input,onDJPort2InputChanged);

	DJCipherInput=document.getElementById("DJCipherInput");
	DJCipher=GetObjCookie(DJCipherInput);
	AETFC(DJCipherInput,onDJCipherInputChanged);

	DJAutoDumpSourceTimeInput=document.getElementById("DJAutoDumpSourceTimeInput");
	DJAutoDumpSourceTime=GetObjCookie(DJAutoDumpSourceTimeInput)*1;
	AETFC(DJAutoDumpSourceTimeInput,onDJAutoDumpSourceTimeInputChanged);

	DJCaptureEnableCheckBox=document.getElementById("DJCaptureEnableCheckBox");
	DJCaptureEnable=GetObjCookie(DJCaptureEnableCheckBox);
	AETFC(DJCaptureEnableCheckBox,onDJCaptureEnableCheckBoxClicked);

	DJBroadcastsPathInput=document.getElementById("DJBroadcastsPathInput");
	DJBroadcastsPath=GetObjCookie(DJBroadcastsPathInput);
	AETFC(DJBroadcastsPathInput,onDJBroadcastsPathInputChanged);

	DJFilePatternInput=document.getElementById("DJFilePatternInput");
	DJFilePattern=GetObjCookie(DJFilePatternInput);
	AETFC(DJFilePatternInput,onDJFilePatternInputChanged);

	MultiCalendarSpan=document.getElementById("MultiCalendarSpan");
	NumOfCalendarEventsHidden=document.getElementById("NumOfCalendarEventsHidden");
	NumOfCalendarEvents=GetObjCookie(NumOfCalendarEventsHidden)*1;
	if(NumOfCalendarEvents==null || NumOfCalendarEvents==NaN){NumOfCalendarEvents=0;NumOfCalendarEventsHidden.value=0;}
	AETFC(NumOfCalendarEventsHidden,onNumOfCalendarEventsHiddenChanged);
	MultiCalendarSpanUpdate();

	CalendarEventAddButton=document.getElementById("CalendarEventAddButton");
	AETFC(CalendarEventAddButton,onCalendarEventAddButtonClicked);

	MultiDJSpan=document.getElementById("MultiDJSpan");

	NumOfDJsHidden=document.getElementById("NumOfDJsHidden");
	NumOfDJs=GetObjCookie(NumOfDJsHidden)*1;
	if(NumOfDJs==null || NumOfDJs==NaN){NumOfDJs=0;NumOfDJsHidden.value=0;}
	AETFC(NumOfDJsHidden,onNumOfDJsHiddenChanged);
	MultiDJSpanUpdate();

	DJAddButton=document.getElementById("DJAddButton");
	AETFC(DJAddButton,onDJAddButtonClicked);

	EnableCaptureCheckBox=document.getElementById("EnableCaptureCheckBox");
	EnableCapture=GetObjCookie(EnableCaptureCheckBox);
	AETFC(EnableCaptureCheckBox,onEnableCaptureCheckBoxClicked);

	CaptureDeviceInput=document.getElementById("CaptureDeviceInput");
	CaptureDevice=GetObjCookie(CaptureDeviceInput);
	AETFC(CaptureDeviceInput,onCaptureDeviceInputChanged);

	CaptureInputInput=document.getElementById("CaptureInputInput");
	CaptureInput=GetObjCookie(CaptureInputInput);
	AETFC(CaptureInputInput,onCaptureInputInputChanged);

	CaptureSampleRateInput=document.getElementById("CaptureSampleRateInput");
	CaptureSampleRate=GetObjCookie(CaptureSampleRateInput);
	AETFC(CaptureSampleRateInput,onCaptureSampleRateInputChanged);

	CaptureNumChannelsInput=document.getElementById("CaptureNumChannelsInput");
	CaptureNumChannels=GetObjCookie(CaptureNumChannelsInput);
	AETFC(CaptureNumChannelsInput,onCaptureNumChannelsInputChanged);

	ApplyReplayGainCheckBox=document.getElementById("ApplyReplayGainCheckBox");
	ApplyReplayGain=GetObjCookie(ApplyReplayGainCheckBox);
	AETFC(ApplyReplayGainCheckBox,onApplyReplayGainCheckBoxClicked);

	DefaultReplayGainInput=document.getElementById("DefaultReplayGainInput");
	DefaultReplayGain=GetObjCookie(DefaultReplayGainInput);
	AETFC(DefaultReplayGainInput,onDefaultReplayGainInputChanged);

	DJReplayGainInput=document.getElementById("DJReplayGainInput");
	DJReplayGain=GetObjCookie(DJReplayGainInput);
	AETFC(DJReplayGainInput,onDJReplayGainInputChanged);

	CaptureReplayGainInput=document.getElementById("CaptureReplayGainInput");
	CaptureReplayGain=GetObjCookie(CaptureReplayGainInput);
	AETFC(CaptureReplayGainInput,onCaptureReplayGainInputChanged);

	CalculateReplayGainCheckBox=document.getElementById("CalculateReplayGainCheckBox");
	CalculateReplayGain=GetObjCookie(CalculateReplayGainCheckBox);
	AETFC(CalculateReplayGainCheckBox,onCalculateReplayGainCheckBoxClicked);

	ReplayGainTempFolderInput=document.getElementById("ReplayGainTempFolderInput");
	ReplayGainTempFolder=GetObjCookie(ReplayGainTempFolderInput);
	AETFC(ReplayGainTempFolderInput,onReplayGainTempFolderInputChanged);

	ReplayGainRunAheadInput=document.getElementById("ReplayGainRunAheadInput");
	ReplayGainRunAhead=GetObjCookie(ReplayGainRunAheadInput);
	AETFC(ReplayGainRunAheadInput,onReplayGainRunAheadInputChanged);

	ReplayGainDontWriteCheckBox=document.getElementById("ReplayGainDontWriteCheckBox");
	ReplayGainDontWrite=GetObjCookie(ReplayGainDontWriteCheckBox);
	AETFC(ReplayGainDontWriteCheckBox,onReplayGainDontWriteCheckBoxClicked);

	EnhanceReplayGainInput=document.getElementById("EnhanceReplayGainInput");
	EnhanceReplayGain=GetObjCookie(EnhanceReplayGainInput);
	AETFC(EnhanceReplayGainInput,onEnhanceReplayGainInputChanged);

	DNASConfigreWriteCheckBox=document.getElementById("DNASConfigreWriteCheckBox");
	DNASConfigreWrite=GetObjCookie(DNASConfigreWriteCheckBox);
	AETFC(DNASConfigreWriteCheckBox,onDNASConfigreWriteCheckBoxClicked);

	TransConfigreWriteCheckBox=document.getElementById("TransConfigreWriteCheckBox");
	TransConfigreWrite=GetObjCookie(TransConfigreWriteCheckBox);
	AETFC(TransConfigreWriteCheckBox,onTransConfigreWriteCheckBoxClicked);

	DNASAdminPageThemeInput=document.getElementById("DNASAdminPageThemeInput");
	DNASAdminPageTheme=GetObjCookie(DNASAdminPageThemeInput);
	AETFC(DNASAdminPageThemeInput,onDNASAdminPageThemeInputChanged);

	TimeMultiplierInput=document.getElementById("TimeMultiplierInput");
	TimeMultiplier=GetObjCookie(TimeMultiplierInput);
	AETFC(TimeMultiplierInput,onTimeMultiplierInputChanged);

	DNASIntroFileInput=document.getElementById("DNASIntroFileInput");
	DNASIntroFile=GetObjCookie(DNASIntroFileInput);
	AETFC(DNASIntroFileInput,onDNASIntroFileInputChanged);

	DNASBackupFileInput=document.getElementById("DNASBackupFileInput");
	DNASBackupFile=GetObjCookie(DNASBackupFileInput);
	AETFC(DNASBackupFileInput,onDNASBackupFileInputChanged);

	DNASSpecialFileTmpDirInput=document.getElementById("DNASSpecialFileTmpDirInput");
	DNASSpecialFileTmpDir=GetObjCookie(DNASSpecialFileTmpDirInput);
	AETFC(DNASSpecialFileTmpDirInput,onDNASSpecialFileTmpDirInputChanged);

	MaxSpecialFileSizeInput=document.getElementById("MaxSpecialFileSizeInput");
	MaxSpecialFileSize=GetObjCookie(MaxSpecialFileSizeInput)*1;
	AETFC(MaxSpecialFileSizeInput,onMaxSpecialFileSizeInputChanged);

	ServerBackupFileInput=document.getElementById("ServerBackupFileInput");
	ServerBackupFile=GetObjCookie(ServerBackupFileInput);
	AETFC(ServerBackupFileInput,onServerBackupFileInputChanged);

	ServerIntroFileInput=document.getElementById("ServerIntroFileInput");
	ServerIntroFile=GetObjCookie(ServerIntroFileInput);
	AETFC(ServerIntroFileInput,onServerIntroFileInputChanged);

	SongHistoryInput=document.getElementById("SongHistoryInput");
	SongHistory=GetObjCookie(SongHistoryInput);
	AETFC(SongHistoryInput,onSongHistoryInputChanged);

	ResetButton=document.getElementById("ResetButton");
	AETFC(ResetButton,onResetButtonClicked);

	DownloadConfigHelpButton=document.getElementById("DownloadConfigHelpButton");
	AETFC(DownloadConfigHelpButton,null);

	DownloadSCServHelpButton=document.getElementById("DownloadSCServHelpButton");
	AETFC(DownloadSCServHelpButton,null);

	DownloadSCTransHelpButton=document.getElementById("DownloadSCTransHelpButton");
	AETFC(DownloadSCTransHelpButton,null);

	DownloadCalendarHelpButton=document.getElementById("DownloadCalendarHelpButton");
	AETFC(DownloadCalendarHelpButton,null);

	DownloadDNASLaunchFileHelpButton=document.getElementById("DownloadDNASLaunchFileHelpButton");
	AETFC(DownloadDNASLaunchFileHelpButton,null);

	DownloadTransLaunchFileHelpButton=document.getElementById("DownloadTransLaunchFileHelpButton");
	AETFC(DownloadTransLaunchFileHelpButton,null);

	NumOfEndPointsInput=document.getElementById("NumOfEndPointsInput");
	var w=GetObjCookie(NumOfEndPointsInput)*1;
	NumOfEndPointsInput.value=w;
	if(Mode*1==2){NumOfEndPoints=w;}else{NumOfEndPoints=0;}
	AETFC(NumOfEndPointsInput,onNumOfEndPointsInputChanged);
	MultiPointSpanUpdate(NumOfEndPoints);
	DoModeSelectUpdate(Mode);

	DoPlatformSelectUpdate(Platform);

	DNASDebugTable=document.getElementById("DNASDebugTable");

	DNASDebugModeNoneRadio=document.getElementById("DNASDebugModeNoneRadio");
	AETFC(DNASDebugModeNoneRadio,onDNASDebugModeNoneRadioClicked);

	DNASDebugModeAllRadio=document.getElementById("DNASDebugModeAllRadio");
	AETFC(DNASDebugModeAllRadio,onDNASDebugModeAllRadioClicked);

	DNASDebugModeCustomRadio=document.getElementById("DNASDebugModeCustomRadio");
	AETFC(DNASDebugModeCustomRadio,onDNASDebugModeCustomRadioClicked);

	DNASDebugModeHidden=document.getElementById("DNASDebugModeHidden");
	DNASDebugMode=GetObjCookie(DNASDebugModeHidden)*1;
	DoDNASDebugModeUpdate(DNASDebugMode);
	AETFC(DNASDebugModeHidden,onDNASDebugModeHiddenChanged);

	TransDebugTable=document.getElementById("TransDebugTable");

	TransDebugModeNoneRadio=document.getElementById("TransDebugModeNoneRadio");
	AETFC(TransDebugModeNoneRadio,onTransDebugModeNoneRadioClicked);

	TransDebugModeAllRadio=document.getElementById("TransDebugModeAllRadio");
	AETFC(TransDebugModeAllRadio,onTransDebugModeAllRadioClicked);

	TransDebugModeCustomRadio=document.getElementById("TransDebugModeCustomRadio");
	AETFC(TransDebugModeCustomRadio,onTransDebugModeCustomRadioClicked);

	TransDebugModeHidden=document.getElementById("TransDebugModeHidden");
	TransDebugMode=GetObjCookie(TransDebugModeHidden)*1;
	DoTransDebugModeUpdate(TransDebugMode);
	AETFC(TransDebugModeHidden,onTransDebugModeHiddenChanged);

	PopUpdateKill();
	DoUpdate();
	DoHelpUpdate(null);
}

function onBodyLoad() {
	InitDownloadifier();
	LoadHelpTextDB();

	var UploadConfigFile=document.getElementById("UploadConfigFile");
	var UploadConfigButton=document.getElementById("UploadConfigButton");
	UploadConfigButton.onclick=onUploadConfigButtonClicked;
	UploadConfigFile.accept="text/plain";

	DoInit();
}

function uht(Obj,t) {
	HelperSpan.innerHTML="<br/>"+t+"<br/><br/>";
	if(!lastHeight || myScrollTable.parentNode.clientHeight < HelperTable.clientHeight) {
		myScrollTable.parentNode.setAttribute("style","height: "+HelperTable.clientHeight+"px;");
	}
	lastHeight = HelperTable.clientHeight;
}

window.onload=onBodyLoad;